/*
    CoolSetup installation system
    Copyright (C) 2001-2002 Andrej Krutak

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <windows.h>
#include <math.h>
#include <commctrl.h>
#include <shlobj.h>
#include "resource.h"
#include "../shared/instclass.h"
#include "./instclass.h"

HINSTANCE hI;

BOOL CALLBACK MainDlgProc(HWND, UINT, WPARAM, LPARAM);
int ExitProgram(HWND);
int SaveProject(char *);
int cs_get_progpath(char *string);
BOOL CALLBACK WinLayoutDlgProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK InstParamsDlgProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK FileGroupsDlgProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK InstTypesDlgProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK RegGroupsDlgProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK GetNameDlgProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK AddFileDlgProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK ChFileDlgProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK ChRegDlgProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK AddRegDlgProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK FIAddDlgProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK RIAddDlgProc(HWND, UINT, WPARAM, LPARAM);
int OpenProject(char *);
HBRUSH bg1, bg2, bg3, bg4, bg5;
RECT rect;
char path[1024], ext[128],name[256], buf[_MAX_PATH];
OPENFILENAME OpenFileName;
BYTE *bits;
BITMAPINFO bmi;
PAINTSTRUCT ps;
CHOOSECOLOR cc;
DWORD lpcc[16];
installfile instfile;
int curfg, curfgi, currg, currgi, curit;
HMENU hm;
MENUITEMINFO mii;
POINT pt;
HANDLE hthread;
DWORD ti;

char& lastchar(char *str)
{
	return str[strlen(str)-1];
}

int MsgBox(UINT fuStyle, char *pszFormat, ...)
{
    va_list     va;
    char		msgMessage[2048];
    int         n;

    va_start(va, pszFormat);
    vsprintf(msgMessage, pszFormat, va);
    va_end(va);

    n = MessageBox(GetFocus(), msgMessage, "CoolSetup composer", fuStyle|MB_SETFOREGROUND|MB_TOPMOST|MB_APPLMODAL);

    return n;
}

int windows_registry_get_value(HKEY root, char *path, char *entry, int type1, void *datapointer, int sod)
{
	HKEY key;
	DWORD size=sod, type;

	if (RegOpenKeyEx(root, path, 0, KEY_READ, &key) != ERROR_SUCCESS)
		return 1;
	RegQueryValueEx(key, entry, NULL, &type, (LPBYTE)datapointer, &size);
	RegCloseKey(key);
	if (type == REG_SZ && type1 == 0)
		return 0;
	if (type == REG_DWORD && type1 == 1)
		return 0;
	return 1;
}

int InitOwnerDrawButtons(void)
{
	char buf[256];
	BYTE r, g, b;
	int ri, gi, bi;

	windows_registry_get_value(HKEY_CURRENT_USER, "Control Panel\\Colors",	"ButtonFace", 0, (void*)buf, 256);
	sscanf(buf, "%d %d %d", &ri, &gi, &bi);
	r=(BYTE)ri;
	g=(BYTE)gi;
	b=(BYTE)bi;
	bg1=CreateSolidBrush(RGB(r, g, b));
	bg2=CreateSolidBrush(RGB(r+38, g+38, b+38));
	bg3=CreateSolidBrush(RGB(r-32, g-32, b-32));
	bg4=CreateSolidBrush(RGB(r+8, g+8, b+8));
	bg5=CreateSolidBrush(RGB(r-7, g-7, b-7));
	return 0;
}

int DrawButton(HWND hDlg, UINT iid, DRAWITEMSTRUCT* dis)
{
	char buf[512];
	GetWindowText(dis->hwndItem, buf, 2048);
	RECT rect;
	int i;

	if (dis->itemAction==ODA_DRAWENTIRE) {
		FillRect(dis->hDC, &dis->rcItem, bg4);

		rect.top=dis->rcItem.top;
		rect.left=dis->rcItem.left;
		rect.right=dis->rcItem.right;
		rect.bottom=dis->rcItem.top+1;
		FillRect(dis->hDC, &rect, bg5);
		
		rect.top=dis->rcItem.bottom-1;
		rect.left=dis->rcItem.left;
		rect.right=dis->rcItem.right;
		rect.bottom=dis->rcItem.bottom;
		FillRect(dis->hDC, &rect, bg5);
		
		rect.top=dis->rcItem.top;
		rect.left=dis->rcItem.left;
		rect.right=dis->rcItem.left+1;
		rect.bottom=dis->rcItem.bottom;
		FillRect(dis->hDC, &rect, bg5);
		
		rect.top=dis->rcItem.top;
		rect.left=dis->rcItem.right-1;
		rect.right=dis->rcItem.right;
		rect.bottom=dis->rcItem.bottom;
		FillRect(dis->hDC, &rect, bg5);

		i=SetBkMode(dis->hDC, TRANSPARENT);
		DrawText(dis->hDC, buf, strlen(buf), &dis->rcItem, DT_CENTER | DT_VCENTER|DT_SINGLELINE);
		SetBkMode(dis->hDC, i);
		//return 0;
	}
	if (dis->itemAction==ODA_SELECT) {
		FillRect(dis->hDC, &dis->rcItem, bg1);
		
		rect.top=dis->rcItem.top;
		rect.left=dis->rcItem.left;
		rect.right=dis->rcItem.right;
		rect.bottom=dis->rcItem.top+1;
		FillRect(dis->hDC, &rect, bg3);
		
		rect.top=dis->rcItem.bottom-1;
		rect.left=dis->rcItem.left;
		rect.right=dis->rcItem.right;
		rect.bottom=dis->rcItem.bottom;
		FillRect(dis->hDC, &rect, bg2);
		
		rect.top=dis->rcItem.top;
		rect.left=dis->rcItem.left;
		rect.right=dis->rcItem.left+1;
		rect.bottom=dis->rcItem.bottom;
		FillRect(dis->hDC, &rect, bg3);
		
		rect.top=dis->rcItem.top;
		rect.left=dis->rcItem.right-1;
		rect.right=dis->rcItem.right;
		rect.bottom=dis->rcItem.bottom;
		FillRect(dis->hDC, &rect, bg2);

		i=SetBkMode(dis->hDC, TRANSPARENT);
		CopyRect(&rect, &dis->rcItem);
		rect.top+=2;
		rect.left+=2;
		DrawText(dis->hDC, buf, strlen(buf), &rect, DT_CENTER | DT_VCENTER|DT_SINGLELINE);
		SetBkMode(dis->hDC, i);
		//return 0;
	}
	switch (dis->itemState) {
	case ODS_FOCUS:
		FillRect(dis->hDC, &dis->rcItem, bg1);
		rect.top=dis->rcItem.top;
		rect.left=dis->rcItem.left;
		rect.right=dis->rcItem.right;
		rect.bottom=dis->rcItem.top+1;
		FillRect(dis->hDC, &rect, bg2);
		
		rect.top=dis->rcItem.bottom-1;
		rect.left=dis->rcItem.left;
		rect.right=dis->rcItem.right;
		rect.bottom=dis->rcItem.bottom;
		FillRect(dis->hDC, &rect, bg3);
		
		rect.top=dis->rcItem.top;
		rect.left=dis->rcItem.left;
		rect.right=dis->rcItem.left+1;
		rect.bottom=dis->rcItem.bottom;
		FillRect(dis->hDC, &rect, bg2);
		
		rect.top=dis->rcItem.top;
		rect.left=dis->rcItem.right-1;
		rect.right=dis->rcItem.right;
		rect.bottom=dis->rcItem.bottom;
		FillRect(dis->hDC, &rect, bg3);

		i=SetBkMode(dis->hDC, TRANSPARENT);
		DrawText(dis->hDC, buf, strlen(buf), &dis->rcItem, DT_CENTER | DT_VCENTER|DT_SINGLELINE);
		SetBkMode(dis->hDC, i);
		return 0;
	}
	return 0;
}

int deInitOwnerDrawButtons(void)
{
	DeleteObject(bg1);
	DeleteObject(bg2);
	DeleteObject(bg3);
	DeleteObject(bg4);
	DeleteObject(bg5);
	return 0;
}

int WINAPI WinMain(HINSTANCE hIn, HINSTANCE, char *cmdline, int)
{
	char pp[1024];

	hI=hIn;
	InitCommonControls();
	InitOwnerDrawButtons();
	hthread=NULL;
	ti=0;
	bmi.bmiHeader.biWidth = 40;
	bmi.bmiHeader.biHeight = 108;
	bmi.bmiHeader.biPlanes = 1;
	bmi.bmiHeader.biBitCount = 24;
	bmi.bmiHeader.biCompression = BI_RGB;
	bmi.bmiHeader.biSizeImage = 0;
	bmi.bmiHeader.biXPelsPerMeter = 0;
	bmi.bmiHeader.biYPelsPerMeter = 0;
	bmi.bmiHeader.biClrUsed = 0;
	bmi.bmiHeader.biClrImportant = 0;
	bmi.bmiHeader.biSize = sizeof(bmi.bmiHeader);
	if (strcmp(cmdline, "")) {
		strcpy(pp, cmdline);
		if(pp[0]=='"') {
			strcpy(pp, &pp[1]);
			pp[strlen(pp)-1]='\0';
		}
		OpenProject(pp);
	}
	DialogBox(hI, "MAIN", NULL, (DLGPROC)MainDlgProc);
	return 0;
}

DWORD WINAPI CompileFile_2(LPVOID lpParameter)
{
	instfile.compile((HWND)lpParameter);
	hthread=NULL;
	return 0;
}

int CompileFile(HWND progress)
{
	if (hthread) {
		MsgBox(MB_OK|MB_ICONSTOP, "Another compilation in progress, this one can be not executed...");
		return 0;
	}
	hthread=CreateThread(NULL, 0, CompileFile_2, (LPVOID)progress, 0, &ti);
	return 0;
}

BOOL CALLBACK MainDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	HICON hiconItem;
	HIMAGELIST himlLarge;
	LV_ITEM lvi;

	switch (uMsg) {
	case WM_INITDIALOG:
		himlLarge = ImageList_Create(GetSystemMetrics(SM_CXICON), GetSystemMetrics(SM_CYICON), ILC_COLOR24, 2, 2);
		hiconItem = LoadIcon(hI, "ICON4");
		ImageList_AddIcon(himlLarge, hiconItem);
		DeleteObject(hiconItem);
		hiconItem = LoadIcon(hI, "ICON3");
		ImageList_AddIcon(himlLarge, hiconItem);
		DeleteObject(hiconItem);
		hiconItem = LoadIcon(hI, "ICON5");
		ImageList_AddIcon(himlLarge, hiconItem);
		DeleteObject(hiconItem);
		hiconItem = LoadIcon(hI, "ICON6");
		ImageList_AddIcon(himlLarge, hiconItem);
		DeleteObject(hiconItem);
		hiconItem = LoadIcon(hI, "ICON7");
		ImageList_AddIcon(himlLarge, hiconItem);
		DeleteObject(hiconItem);
		ListView_SetImageList(GetDlgItem(hDlg, IDC_LIST1), himlLarge, LVSIL_NORMAL);

		lvi.mask=LVIF_TEXT|LVIF_IMAGE|LVIF_STATE;
		lvi.iItem=0;
		lvi.iSubItem=0;
		lvi.state=LVIS_FOCUSED|LVIS_SELECTED;
		lvi.stateMask=LVIS_STATEIMAGEMASK;
		lvi.pszText="Window layout";
		lvi.iImage=0;
		ListView_InsertItem(GetDlgItem(hDlg, IDC_LIST1), &lvi);
		
		lvi.mask=LVIF_TEXT|LVIF_IMAGE;
		lvi.stateMask=0;
		lvi.iItem=1;
		lvi.pszText="Installation parameters";
		lvi.iImage=1;
		ListView_InsertItem(GetDlgItem(hDlg, IDC_LIST1), &lvi);

		lvi.iItem=2;
		lvi.pszText="File groups";
		lvi.iImage=2;
		ListView_InsertItem(GetDlgItem(hDlg, IDC_LIST1), &lvi);

		lvi.iItem=3;
		lvi.pszText="Registry actions groups";
		lvi.iImage=3;
		ListView_InsertItem(GetDlgItem(hDlg, IDC_LIST1), &lvi);

		lvi.iItem=4;
		lvi.pszText="Installation types";
		lvi.iImage=4;
		ListView_InsertItem(GetDlgItem(hDlg, IDC_LIST1), &lvi);
		SendMessage(GetDlgItem(hDlg, IDC_PROGRESS1), PBM_SETRANGE, 0, MAKELPARAM(0, 4));
		SendMessage(GetDlgItem(hDlg, IDC_PROGRESS1), PBM_SETSTEP, (WPARAM)1, 0);
		//SendMessage(GetDlgItem(hDlg, IDC_PROGRESS1), PBM_STEPIT, 0, 0);
		SetDlgItemText(hDlg, IDC_EDIT1, instfile.outputpath);
		return TRUE;
	case WM_DRAWITEM:
		if (!DrawButton(hDlg, (UINT)wParam, (DRAWITEMSTRUCT*)lParam))
			return TRUE;
		else
			return 0;
	case WM_NOTIFY:
		if (((NMHDR*)lParam)->code==NM_DBLCLK|| (((NMHDR*)lParam)->code==LVN_KEYDOWN&&((LV_KEYDOWN*)lParam)->wVKey==VK_SPACE))
		{
			if (ListView_GetItemState(GetDlgItem(hDlg, IDC_LIST1), 0, LVIS_FOCUSED)) {
				if (hthread) {
					MsgBox(MB_OK, "Compilation in progress!");
					return 0;
				}
				DialogBox(hI, "WINLAYOUT", hDlg, (DLGPROC)WinLayoutDlgProc);
			}
			if (ListView_GetItemState(GetDlgItem(hDlg, IDC_LIST1), 1, LVIS_FOCUSED)) {
				if (hthread) {
					MsgBox(MB_OK, "Compilation in progress!");
					return 0;
				}
				DialogBox(hI, "INSTPARAMS", hDlg, (DLGPROC)InstParamsDlgProc);
			}
			if (ListView_GetItemState(GetDlgItem(hDlg, IDC_LIST1), 2, LVIS_FOCUSED)) {
				if (hthread) {
					MsgBox(MB_OK, "Compilation in progress!");
					return 0;
				}
				DialogBox(hI, "FILEGROUPS", hDlg, (DLGPROC)FileGroupsDlgProc);
			}
			if (ListView_GetItemState(GetDlgItem(hDlg, IDC_LIST1), 3, LVIS_FOCUSED)) {
				if (hthread) {
					MsgBox(MB_OK, "Compilation in progress!");
					return 0;
				}
				DialogBox(hI, "REGGROUPS", hDlg, (DLGPROC)RegGroupsDlgProc);
			}
			if (ListView_GetItemState(GetDlgItem(hDlg, IDC_LIST1), 4, LVIS_FOCUSED)) {
				if (hthread) {
					MsgBox(MB_OK, "Compilation in progress!");
					return 0;
				}
				DialogBox(hI, "INSTTYPES", hDlg, (DLGPROC)InstTypesDlgProc);
			}
			return 0;
		}
		return 0;
	case WM_CLOSE:
		if (hthread) {
			MsgBox(MB_OK, "Compilation in progress!");
			return 0;
		}
		ExitProgram(hDlg);
		return 0;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_BUTTON1:
			if (hthread) {
				MsgBox(MB_OK, "Compilation in progress!");
				return 0;
			}
			GetModuleFileName(hI, path, 1024);
			ShellExecute(NULL, "open", path, NULL, ".", SW_SHOW);
			return 0;
		case IDC_BUTTON2:
			if (hthread) {
				MsgBox(MB_OK, "Compilation in progress!");
				return 0;
			}
			OpenProject(NULL);
			SetDlgItemText(hDlg, IDC_EDIT1, instfile.outputpath);
			return 0;
		case IDC_BUTTON4:
			if (hthread) {
				MsgBox(MB_OK, "Compilation in progress!");
				return 0;
			}
			GetDlgItemText(hDlg, IDC_EDIT1, instfile.outputpath, 1024);
			OpenFileName.lStructSize		= sizeof(OPENFILENAME);
			OpenFileName.lpstrTitle			= "Select output file...";
			OpenFileName.hwndOwner			= GetFocus();
			OpenFileName.hInstance			= hI;
			OpenFileName.lpstrFilter		= "EXE executable file\0*.exe\0";
			OpenFileName.lpstrCustomFilter	= NULL;
			OpenFileName.nMaxCustFilter		= 0;
			OpenFileName.nFilterIndex		= 0;
			OpenFileName.lpstrFile			= instfile.outputpath;
			OpenFileName.nMaxFile			= 2048;
			OpenFileName.lpstrFileTitle		= NULL;
			OpenFileName.nMaxFileTitle		= 0;
			OpenFileName.lpstrInitialDir	= NULL;
			OpenFileName.nFileOffset		= 0;
			OpenFileName.nFileExtension		= 0;
			OpenFileName.lpstrDefExt		= NULL;
			OpenFileName.Flags				= OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT;
			
			if (!GetSaveFileName(&OpenFileName))
				return 0;
			strcpy(instfile.outputpath, OpenFileName.lpstrFile);
			_splitpath(instfile.outputpath, NULL, NULL, NULL, ext);
			if (strcmpi(ext, ".exe"))
				strcat(instfile.outputpath, ".exe");
			SetDlgItemText(hDlg, IDC_EDIT1, instfile.outputpath);
			return 0;
		case IDC_BUTTON6:
			if (hthread) {
				MsgBox(MB_OK, "Compilation in progress!");
				return 0;
			}
			GetDlgItemText(hDlg, IDC_EDIT1, instfile.outputpath, 1024);
			SaveProject(NULL);
			return 0;
		case IDC_BUTTON3:
			if (hthread) {
				MsgBox(MB_OK, "Compilation in progress!");
				return 0;
			}
			GetDlgItemText(hDlg, IDC_EDIT1, instfile.outputpath, 1024);
			SaveProject(instfile.projpath);
			return 0;
		case IDC_BUTTON7:
			if (hthread) {
				MsgBox(MB_OK, "Compilation in progress!");
				return 0;
			}
			ExitProgram(hDlg);
			return 0;
		case IDC_BUTTON5:
			if (hthread) {
				MsgBox(MB_OK, "Compilation in progress!");
				return 0;
			}
			GetDlgItemText(hDlg, IDC_EDIT1, instfile.outputpath, 1024);
			SaveProject(instfile.projpath);
			CompileFile(GetDlgItem(hDlg, IDC_PROGRESS1));
			return 0;
		case IDC_BUTTON8:
			if (hthread) {
				MsgBox(MB_OK, "Compilation in progress!");
				return 0;
			}
			GetDlgItemText(hDlg, IDC_EDIT1, instfile.outputpath, 1024);
			ShellExecute(hDlg, "open", instfile.outputpath, "", ".", SW_SHOW);
			return 0;
		}
	}
	return 0;
}

int ExitProgram(HWND hDlg)
{
	EndDialog(hDlg, 0);
	return 0;
}

int SaveProject(char *path)
{
	char ext[50];

	if (path==NULL)
	{
		OpenFileName.lStructSize		= sizeof(OPENFILENAME);
		OpenFileName.lpstrTitle			= "Save project as...";
		OpenFileName.hwndOwner			= GetFocus();
		OpenFileName.hInstance			= hI;
		OpenFileName.lpstrFilter		= "CSP CoolSetup project files\0*.csp\0";
		OpenFileName.lpstrCustomFilter	= NULL;
		OpenFileName.nMaxCustFilter		= 0;
		OpenFileName.nFilterIndex		= 0;
		OpenFileName.lpstrFile			= instfile.projpath;
		OpenFileName.nMaxFile			= 2048;
		OpenFileName.lpstrFileTitle		= NULL;
		OpenFileName.nMaxFileTitle		= 0;
		OpenFileName.lpstrInitialDir	= NULL;
		OpenFileName.nFileOffset		= 0;
		OpenFileName.nFileExtension		= 0;
		OpenFileName.lpstrDefExt		= NULL;
		OpenFileName.Flags				= OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY;
		
		if (!GetSaveFileName(&OpenFileName))
			return 0;
	}
	_splitpath(instfile.projpath, NULL, NULL, NULL, ext);
	if (strcmpi(ext, ".csp"))
		strcat(instfile.projpath, ".csp");
	instfile.save(instfile.projpath);
	return 0;
}

int OpenProject(char *path)
{
	if (path==NULL)
	{
		OpenFileName.lStructSize		= sizeof(OPENFILENAME);
		OpenFileName.lpstrTitle			= "Open project...";
		OpenFileName.hwndOwner			= GetFocus();
		OpenFileName.hInstance			= hI;
		OpenFileName.lpstrFilter		= "CSP CoolSetup project files\0*.csp\0";
		OpenFileName.lpstrCustomFilter	= NULL;
		OpenFileName.nMaxCustFilter		= 0;
		OpenFileName.nFilterIndex		= 0;
		OpenFileName.lpstrFile			= instfile.projpath;
		OpenFileName.nMaxFile			= 2048;
		OpenFileName.lpstrFileTitle		= NULL;
		OpenFileName.nMaxFileTitle		= 0;
		OpenFileName.lpstrInitialDir	= NULL;
		OpenFileName.nFileOffset		= 0;
		OpenFileName.nFileExtension		= 0;
		OpenFileName.lpstrDefExt		= NULL;
		OpenFileName.Flags				= OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY|OFN_FILEMUSTEXIST;
		
		if (!GetOpenFileName(&OpenFileName))
			return 0;
		strcpy(instfile.projpath, OpenFileName.lpstrFile);
	}
	else
		strcpy(instfile.projpath, path);
	instfile.load(instfile.projpath);
	return 0;
}

int render_blend(void)
{
	int i, j;
	float v1, v2, v3, v4, v5, v6, v7, v8, v9;

	if (bits==NULL)
		bits = (BYTE*)GlobalAlloc(GPTR, 40*108*3);
	v1=(float)GetRValue(instfile.topcolor);
	v2=(float)GetGValue(instfile.topcolor);
	v3=(float)GetBValue(instfile.topcolor);
	
	v4=(float)GetRValue(instfile.bottomcolor);
	v5=(float)GetGValue(instfile.bottomcolor);
	v6=(float)GetBValue(instfile.bottomcolor);
	v7=(v4-v1)/108;
	v8=(v5-v2)/108;
	v9=(v6-v3)/108;
	for (i=0; i<108; i++) {
		for (j=0; j<40; j++) {
			bits[40*3*(108-i-1)+j*3+2] = (int)v1;
			bits[40*3*(108-i-1)+j*3+1] = (int)v2;
			bits[40*3*(108-i-1)+j*3+0] = (int)v3;
		}
		v1+=v7;
		v2+=v8;
		v3+=v9;
	}
	return 0;
}

BOOL CALLBACK WinLayoutDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;

	switch (uMsg) {
	case WM_INITDIALOG:
		SetDlgItemText(hDlg, IDC_EDIT1, instfile.windowcaption);
		SetDlgItemText(hDlg, IDC_EDIT2, instfile.bigcaption);
		SetDlgItemText(hDlg, IDC_EDIT3, instfile.copyright);
		CheckDlgButton(hDlg, IDC_CHECK1, instfile.showbgwin);
		CheckDlgButton(hDlg, IDC_CHECK2, instfile.gofullscreen);
		render_blend();
		return TRUE;
	case WM_PAINT:
		hdc=BeginPaint(hDlg, &ps);
		StretchDIBits(hdc, 350, 140, 40, 108, 0, 0, 40, 108, (void*)bits, &bmi, DIB_RGB_COLORS, SRCCOPY);
		EndPaint(hDlg, &ps);
		return 0;
	case WM_CLOSE:
		SendMessage(hDlg, WM_COMMAND, MAKEWPARAM(IDOK, 0), 0);
		return 0;
	case WM_DRAWITEM:
		if (!DrawButton(hDlg, (UINT)wParam, (DRAWITEMSTRUCT*)lParam))
			return TRUE;
		else
			return 0;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_BUTTON1:
			cc.lStructSize = sizeof(cc);
			cc.hwndOwner = hDlg;
			cc.hInstance = (HWND)hI;
			cc.rgbResult =instfile. topcolor;
			cc.lpCustColors = lpcc;
			cc.Flags = CC_FULLOPEN | CC_RGBINIT;
			ChooseColor(&cc);
			instfile.topcolor = cc.rgbResult;
			render_blend();
			GetClientRect(hDlg, &rect);
			InvalidateRect(hDlg, &rect, TRUE);
			UpdateWindow(hDlg);
			return 0;
		case IDC_BUTTON2:
			cc.lStructSize = sizeof(cc);
			cc.hwndOwner = hDlg;
			cc.hInstance = (HWND)hI;
			cc.rgbResult = instfile.bottomcolor;
			cc.lpCustColors = lpcc;
			cc.Flags = CC_FULLOPEN | CC_RGBINIT;
			ChooseColor(&cc);
			instfile.bottomcolor = cc.rgbResult;
			render_blend();
			GetClientRect(hDlg, &rect);
			InvalidateRect(hDlg, &rect, TRUE);
			UpdateWindow(hDlg);
			return 0;
		case IDOK:
			GetDlgItemText(hDlg, IDC_EDIT1, instfile.windowcaption, 256);
			GetDlgItemText(hDlg, IDC_EDIT2, instfile.bigcaption, 256);
			GetDlgItemText(hDlg, IDC_EDIT3, instfile.copyright, 256);
			instfile.showbgwin=IsDlgButtonChecked(hDlg, IDC_CHECK1);
			instfile.gofullscreen=IsDlgButtonChecked(hDlg, IDC_CHECK2);
			GlobalFree(bits);
			bits=NULL;
			EndDialog(hDlg, 0);
			return 0;
		case IDCANCEL:
			GlobalFree(bits);
			bits=NULL;
			EndDialog(hDlg, 1);
			return 0;
		}
	}
	return 0;
}

int InstParams2(HWND hDlg)
{
	if (IsDlgButtonChecked(hDlg, IDC_CHECK2)) {
		ShowWindow(GetDlgItem(hDlg, IDC_EDIT1), SW_SHOW);
		ShowWindow(GetDlgItem(hDlg, IDC_BUTTON1), SW_SHOW);
	}
	else {
		ShowWindow(GetDlgItem(hDlg, IDC_EDIT1), SW_HIDE);
		ShowWindow(GetDlgItem(hDlg, IDC_BUTTON1), SW_HIDE);
	}

	if (IsDlgButtonChecked(hDlg, IDC_CHECK3)) {
		ShowWindow(GetDlgItem(hDlg, IDC_EDIT2), SW_SHOW);
		ShowWindow(GetDlgItem(hDlg, IDC_BUTTON2), SW_SHOW);
	}
	else {
		ShowWindow(GetDlgItem(hDlg, IDC_EDIT2), SW_HIDE);
		ShowWindow(GetDlgItem(hDlg, IDC_BUTTON2), SW_HIDE);
	}

	if (IsDlgButtonChecked(hDlg, IDC_CHECK7)) {
		ShowWindow(GetDlgItem(hDlg, IDC_EDIT8), SW_SHOW);
	}
	else {
		ShowWindow(GetDlgItem(hDlg, IDC_EDIT8), SW_HIDE);
	}
	return 0;
}

BOOL CALLBACK InstParamsDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	char buf[_MAX_PATH];
	
	switch (uMsg) {
	case WM_INITDIALOG:
		CheckDlgButton(hDlg, IDC_CHECK1, instfile.showwelcome);
		CheckDlgButton(hDlg, IDC_CHECK2, instfile.showlicense);
		SetDlgItemText(hDlg, IDC_EDIT1, instfile.licensefile);
		CheckDlgButton(hDlg, IDC_CHECK3, instfile.showreadme);
		SetDlgItemText(hDlg, IDC_EDIT2, instfile.readmefile);
		CheckDlgButton(hDlg, IDC_CHECK4, instfile.showtarget);
		CheckDlgButton(hDlg, IDC_CHECK7, instfile.enableuninstallation);
		SetDlgItemText(hDlg, IDC_EDIT4, instfile.defprogdir);
		SetDlgItemText(hDlg, IDC_EDIT5, instfile.defmenudir);
		SetDlgItemText(hDlg, IDC_EDIT8, instfile.uninstkey);
		SetDlgItemInt(hDlg, IDC_EDIT3, instfile.compressionstrength, FALSE);
		CheckDlgButton(hDlg, IDC_CHECK8, instfile.progdircustom);
		CheckDlgButton(hDlg, IDC_CHECK9, instfile.menudircustom);
		SetDlgItemText(hDlg, IDC_EDIT6, instfile.execinst);
		SetDlgItemText(hDlg, IDC_EDIT7, instfile.execuninst);
		CheckDlgButton(hDlg, IDC_CHECK5, instfile.overwriteprompt);
		{
			HANDLE ff;
			WIN32_FIND_DATA wfd;
			int fff=1;
			
			cs_get_progpath(buf);
			strcat(buf, "*.csx");
			for (;;) {
				if (fff) {
					ff=FindFirstFile(buf, &wfd);
					fff=0;
				}
				else
					if (!FindNextFile(ff, &wfd))
						break;
					
					if (ff==NULL)
						break;
					
					if (wfd.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)
						continue;
					
					SendDlgItemMessage(hDlg, IDC_COMBO1, CB_INSERTSTRING, (WPARAM)-1, (LPARAM)wfd.cFileName);
			}
			FindClose(ff);

			SendDlgItemMessage(hDlg, IDC_COMBO1, CB_SETCURSEL, (WPARAM)SendDlgItemMessage(hDlg, IDC_COMBO1, CB_FINDSTRINGEXACT, (WPARAM)-1, (LPARAM)instfile.tgtplatform), 0);
		}
		InstParams2(hDlg);
		return TRUE;
	case WM_CLOSE:
		SendMessage(hDlg, WM_COMMAND, MAKEWPARAM(IDOK, 0), 0);
		return 0;
	case WM_DRAWITEM:
		if (!DrawButton(hDlg, (UINT)wParam, (DRAWITEMSTRUCT*)lParam))
			return TRUE;
		else
			return 0;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDOK:
			instfile.showwelcome=IsDlgButtonChecked(hDlg, IDC_CHECK1);
			instfile.showlicense=IsDlgButtonChecked(hDlg, IDC_CHECK2);
			instfile.showreadme=IsDlgButtonChecked(hDlg, IDC_CHECK3);
			instfile.showtarget=IsDlgButtonChecked(hDlg, IDC_CHECK4);
			instfile.overwriteprompt=IsDlgButtonChecked(hDlg, IDC_CHECK5);
			instfile.enableuninstallation=IsDlgButtonChecked(hDlg, IDC_CHECK7);
			instfile.progdircustom=IsDlgButtonChecked(hDlg, IDC_CHECK8);
			instfile.menudircustom=IsDlgButtonChecked(hDlg, IDC_CHECK9);
			instfile.compressionstrength=GetDlgItemInt(hDlg, IDC_EDIT3, NULL, FALSE);
			SendDlgItemMessage(hDlg, IDC_COMBO1, CB_GETLBTEXT, (WPARAM)SendDlgItemMessage(hDlg, IDC_COMBO1, CB_GETCURSEL, 0, 0), (LPARAM)instfile.tgtplatform);
			GetDlgItemText(hDlg, IDC_EDIT1, instfile.licensefile, 1024);
			if (lastchar(instfile.licensefile)=='\\')
				lastchar(instfile.licensefile)='\0';
			GetDlgItemText(hDlg, IDC_EDIT2, instfile.readmefile, 1024);
			if (lastchar(instfile.readmefile)=='\\')
				lastchar(instfile.readmefile)='\0';
			GetDlgItemText(hDlg, IDC_EDIT4, instfile.defprogdir, 1024);
			if (lastchar(instfile.defprogdir)=='\\')
				lastchar(instfile.defprogdir)='\0';
			GetDlgItemText(hDlg, IDC_EDIT5, instfile.defmenudir, 1024);
			if (lastchar(instfile.defmenudir)=='\\')
				lastchar(instfile.defmenudir)='\0';
			GetDlgItemText(hDlg, IDC_EDIT8, instfile.uninstkey, 1024);
			GetDlgItemText(hDlg, IDC_EDIT6, instfile.execinst, 1024);
			GetDlgItemText(hDlg, IDC_EDIT7, instfile.execuninst, 1024);
			if (instfile.compressionstrength>9)
				instfile.compressionstrength=9;
			if (instfile.compressionstrength<0)
				instfile.compressionstrength=0;
			EndDialog(hDlg, 0);
			return 0;
		case IDC_CHECK2:
		case IDC_CHECK3:
		case IDC_CHECK7:
			InstParams2(hDlg);
			return 0;
		case IDCANCEL:
			EndDialog(hDlg, 1);
			return 0;
		case IDC_BUTTON1:
			GetDlgItemText(hDlg, IDC_EDIT1, buf, _MAX_PATH);
			OpenFileName.lStructSize		= sizeof(OPENFILENAME);
			OpenFileName.lpstrTitle			= "Select readme file...";
			OpenFileName.hwndOwner			= hDlg;
			OpenFileName.hInstance			= hI;
			OpenFileName.lpstrFilter		= "All text files (*.*)\0*.*\0";
			OpenFileName.lpstrCustomFilter	= NULL;
			OpenFileName.nMaxCustFilter		= 0;
			OpenFileName.nFilterIndex		= 0;
			OpenFileName.lpstrFile			= buf;
			OpenFileName.nMaxFile			= 2048;
			OpenFileName.lpstrFileTitle		= NULL;
			OpenFileName.nMaxFileTitle		= 0;
			OpenFileName.lpstrInitialDir	= NULL;
			OpenFileName.nFileOffset		= 0;
			OpenFileName.nFileExtension		= 0;
			OpenFileName.lpstrDefExt		= NULL;
			OpenFileName.Flags				= OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY|OFN_FILEMUSTEXIST;
			
			if (!GetOpenFileName(&OpenFileName))
				return 0;
			SetDlgItemText(hDlg, IDC_EDIT1, OpenFileName.lpstrFile);
			return 0;
		case IDC_BUTTON2:
			GetDlgItemText(hDlg, IDC_EDIT2, buf, _MAX_PATH);
			OpenFileName.lStructSize		= sizeof(OPENFILENAME);
			OpenFileName.lpstrTitle			= "Select license file...";
			OpenFileName.hwndOwner			= hDlg;
			OpenFileName.hInstance			= hI;
			OpenFileName.lpstrFilter		= "All text files (*.*)\0*.*\0";
			OpenFileName.lpstrCustomFilter	= NULL;
			OpenFileName.nMaxCustFilter		= 0;
			OpenFileName.nFilterIndex		= 0;
			OpenFileName.lpstrFile			= buf;
			OpenFileName.nMaxFile			= 2048;
			OpenFileName.lpstrFileTitle		= NULL;
			OpenFileName.nMaxFileTitle		= 0;
			OpenFileName.lpstrInitialDir	= NULL;
			OpenFileName.nFileOffset		= 0;
			OpenFileName.nFileExtension		= 0;
			OpenFileName.lpstrDefExt		= NULL;
			OpenFileName.Flags				= OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY|OFN_FILEMUSTEXIST;
			
			if (!GetOpenFileName(&OpenFileName))
				return 0;
			SetDlgItemText(hDlg, IDC_EDIT2, OpenFileName.lpstrFile);
			return 0;
		}
	}
	return 0;
}

BOOL CALLBACK FileGroupsDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	BROWSEINFO bi;
	LPITEMIDLIST pidl;
	LPITEMIDLIST pidlRoot;
	char path[_MAX_PATH];
	int x, i, k, j;

	switch (uMsg) {
	case WM_INITDIALOG:
		CheckDlgButton(hDlg, IDC_CHECK2, instfile.ajc);
		instfile.putftolistbox(GetDlgItem(hDlg, IDC_LIST1));
		instfile.putfctolistbox(GetDlgItem(hDlg, IDC_LIST2));
		return TRUE;
	case WM_CLOSE:
		SendMessage(hDlg, WM_COMMAND, MAKEWPARAM(IDOK, 0), 0);
		return 0;
	case WM_DRAWITEM:
		if (!DrawButton(hDlg, (UINT)wParam, (DRAWITEMSTRUCT*)lParam))
			return TRUE;
		else
			return 0;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_LIST1:
			if (HIWORD(wParam)==LBN_SELCHANGE) {
				curfg=SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCURSEL, 0, 0);
				instfile.curf=SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCURSEL, 0, 0);
				instfile.putftolistbox(GetDlgItem(hDlg, IDC_LIST1));
				instfile.putfctolistbox(GetDlgItem(hDlg, IDC_LIST2));
			}
			if (HIWORD(wParam)==LBN_DBLCLK) {
				curfg=SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCURSEL, 0, 0);
				strcpy(name, instfile.fg[curfg]->name);
				DialogBox(hI, "ADDITEM", hDlg, (DLGPROC)GetNameDlgProc);
				strcpy(instfile.fg[curfg]->name, name);
				instfile.putftolistbox(GetDlgItem(hDlg, IDC_LIST1));
			}
			return 0;
		case IDC_LIST2:
			if (HIWORD(wParam)==LBN_DBLCLK) {
				curfg=SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCURSEL, 0, 0);
				x=SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCOUNT, 0, 0);
				for (i=0; i<x; i++) {
					if (SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETSEL, (WPARAM)i, 0)>0) {
						curfgi=SendDlgItemMessage(hDlg, IDC_LIST2, LB_GETCURSEL, 0, 0);
						break;
					}
				}
				
				if (!DialogBox(hI, "ADDFILE", hDlg, (DLGPROC)ChFileDlgProc)) {
					instfile.putftolistbox(GetDlgItem(hDlg, IDC_LIST1));
					instfile.putfctolistbox(GetDlgItem(hDlg, IDC_LIST2));
				}
			}
			return 0;
		case IDC_BUTTON2:
			curfg=SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCURSEL, 0, 0);
			j=instfile.fg[curfg]->fgino;
			k=0;
			for (i=0; i<j; i++) {
				if (SendDlgItemMessage(hDlg, IDC_LIST2, LB_GETSEL, i, 0)>0) {
					instfile.remffromgrp(SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCURSEL, 0, 0), i-k);
					k++;
				}
			}
			instfile.putftolistbox(GetDlgItem(hDlg, IDC_LIST1));
			instfile.putfctolistbox(GetDlgItem(hDlg, IDC_LIST2));
			return 0;
		case IDC_BUTTON7:
			strcpy(name, "");
			DialogBox(hI, "ADDITEM", hDlg, (DLGPROC)GetNameDlgProc);
			instfile.newfgrp(name);
			instfile.putftolistbox(GetDlgItem(hDlg, IDC_LIST1));
			instfile.putfctolistbox(GetDlgItem(hDlg, IDC_LIST2));
			return 0;

		case IDC_BUTTON9:
			j=SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCURSEL, 0, 0);
			for (i=0; i<instfile.itno; i++) {
				for (k=0; k<instfile.it[i]->fgno; k++) {
					if (instfile.it[i]->fg[k]==j) {
						MsgBox(MB_OK|MB_ICONSTOP, "Install type '%s' contains file group '%s'! You can't delete it until you remove it from that install type", instfile.it[i]->name, instfile.fg[j]->name);
						return 0;
					}
				}
			}
			instfile.remfgrp(j);
			instfile.putftolistbox(GetDlgItem(hDlg, IDC_LIST1));
			instfile.putfctolistbox(GetDlgItem(hDlg, IDC_LIST2));
			SendDlgItemMessage(hDlg, IDC_LIST1, LB_SETCURSEL, (WPARAM)0, 0);
			instfile.curf=curfg=0;
			return 0;
		case IDC_BUTTON1:
			if (instfile.fgno>0) {
				curfg=SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCURSEL, 0, 0);
				instfile.curf=SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCURSEL, 0, 0);
				if (!DialogBox(hI, "ADDFILE", hDlg, (DLGPROC)AddFileDlgProc)) {
					instfile.putftolistbox(GetDlgItem(hDlg, IDC_LIST1));
					instfile.putfctolistbox(GetDlgItem(hDlg, IDC_LIST2));
				}
			}
			return 0;
		case IDOK:
			instfile.ajc=IsDlgButtonChecked(hDlg, IDC_CHECK2);
			EndDialog(hDlg, 0);
			return 0;
		case IDCANCEL:
			EndDialog(hDlg, 1);
			return 0;
		case IDC_BUTTON3:
			if (instfile.fgno<=0)
				return 0;
			bi.hwndOwner=hDlg;
			bi.pidlRoot=NULL;
			bi.pszDisplayName=path;
			bi.lpszTitle="Select directory you want to add:";
			bi.ulFlags=BIF_RETURNONLYFSDIRS;
			bi.lpfn=NULL;
			bi.lParam=0L;
			bi.iImage=0;
			if (SHGetSpecialFolderLocation(HWND_DESKTOP, CSIDL_DRIVES, &pidlRoot)!=NOERROR)
				return 0;
			if (NULL == pidlRoot)
				return 0;
			bi.pidlRoot = pidlRoot;
			pidl=SHBrowseForFolder(&bi);
			if (NULL != pidl)
				SHGetPathFromIDList(pidl, path);
			else
				return 0;
			curfg=SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCURSEL, 0, 0);
			instfile.ajc=IsDlgButtonChecked(hDlg, IDC_CHECK2);
			instfile.fg[curfg]->rmfp=strlen(path);
			instfile.fg[curfg]->adddirectory(path, instfile.ajc);
			instfile.putftolistbox(GetDlgItem(hDlg, IDC_LIST1));
			instfile.putfctolistbox(GetDlgItem(hDlg, IDC_LIST2));
			return 0;
		case IDC_BUTTON4:
			SendDlgItemMessage(hDlg, IDC_LIST2, LB_SETSEL, (WPARAM)TRUE, (LPARAM)-1);
			return 0;
		case IDC_BUTTON10:
			curfg=SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCURSEL, 0, 0);

			for (i=0; i<instfile.fg[curfg]->fgino; i++) {
				if (SendDlgItemMessage(hDlg, IDC_LIST2, LB_GETSEL, (WPARAM)i, (LPARAM)0)>0)
					SendDlgItemMessage(hDlg, IDC_LIST2, LB_SETSEL, (WPARAM)FALSE, (LPARAM)i);
				else
					SendDlgItemMessage(hDlg, IDC_LIST2, LB_SETSEL, (WPARAM)TRUE, (LPARAM)i);
			}
			return 0;
		}
	}
	return 0;
}

BOOL CALLBACK AddFileDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg) {
	case WM_INITDIALOG:
		SendMessage(hDlg, WM_COMMAND, MAKEWPARAM(IDC_CHECK1, 0), 0);
		return TRUE;
	case WM_DRAWITEM:
		if (!DrawButton(hDlg, (UINT)wParam, (DRAWITEMSTRUCT*)lParam))
			return TRUE;
		else
			return 0;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDOK:
			if (instfile.addftogrp()) {
				MsgBox(MB_OK|MB_ICONWARNING, "Out of memory or you reached the maximum count of items in single file group!");
				return 1;
			}
			GetDlgItemText(hDlg, IDC_EDIT1, instfile.fg[curfg]->fgi[instfile.fg[curfg]->fgino-1]->source, _MAX_PATH);
			if (lastchar(instfile.fg[curfg]->fgi[instfile.fg[curfg]->fgino-1]->source)=='\\')
				lastchar(instfile.fg[curfg]->fgi[instfile.fg[curfg]->fgino-1]->source)='\0';
			GetDlgItemText(hDlg, IDC_EDIT2, instfile.fg[curfg]->fgi[instfile.fg[curfg]->fgino-1]->target, _MAX_PATH);
			if (lastchar(instfile.fg[curfg]->fgi[instfile.fg[curfg]->fgino-1]->target)=='\\')
				lastchar(instfile.fg[curfg]->fgi[instfile.fg[curfg]->fgino-1]->target)='\0';
			GetDlgItemText(hDlg, IDC_EDIT4, instfile.fg[curfg]->fgi[instfile.fg[curfg]->fgino-1]->lname, 64);
			if (lastchar(instfile.fg[curfg]->fgi[instfile.fg[curfg]->fgino-1]->lname)=='\\')
				lastchar(instfile.fg[curfg]->fgi[instfile.fg[curfg]->fgino-1]->lname)='\0';
			GetDlgItemText(hDlg, IDC_EDIT5, instfile.fg[curfg]->fgi[instfile.fg[curfg]->fgino-1]->ltargetdir, 128);
			if (lastchar(instfile.fg[curfg]->fgi[instfile.fg[curfg]->fgino-1]->ltargetdir)=='\\')
				lastchar(instfile.fg[curfg]->fgi[instfile.fg[curfg]->fgino-1]->ltargetdir)='\0';
			GetDlgItemText(hDlg, IDC_EDIT6, instfile.fg[curfg]->fgi[instfile.fg[curfg]->fgino-1]->ldescr, 64);
			GetDlgItemText(hDlg, IDC_EDIT7, instfile.fg[curfg]->fgi[instfile.fg[curfg]->fgino-1]->liconpath, _MAX_PATH);
			if (lastchar(instfile.fg[curfg]->fgi[instfile.fg[curfg]->fgino-1]->liconpath)=='\\')
				lastchar(instfile.fg[curfg]->fgi[instfile.fg[curfg]->fgino-1]->liconpath)='\0';
			GetDlgItemText(hDlg, IDC_EDIT9, instfile.fg[curfg]->fgi[instfile.fg[curfg]->fgino-1]->lwrkdir, _MAX_DIR+_MAX_DRIVE);
			if (lastchar(instfile.fg[curfg]->fgi[instfile.fg[curfg]->fgino-1]->lwrkdir)=='\\')
				lastchar(instfile.fg[curfg]->fgi[instfile.fg[curfg]->fgino-1]->lwrkdir)='\0';
			instfile.fg[curfg]->fgi[instfile.fg[curfg]->fgino-1]->liconnum=GetDlgItemInt(hDlg, IDC_EDIT8, NULL, FALSE);
			instfile.fg[curfg]->fgi[instfile.fg[curfg]->fgino-1]->link=IsDlgButtonChecked(hDlg, IDC_CHECK1);
			EndDialog(hDlg, 0);
			return 0;
		case IDCANCEL:
			EndDialog(hDlg, 1);
			return 0;
		case IDC_BUTTON2:
			GetDlgItemText(hDlg, IDC_EDIT1, buf, _MAX_PATH);
			SetDlgItemText(hDlg, IDC_EDIT2, buf);
			return 0;
		case IDC_BUTTON6:
			GetCursorPos(&pt);
			hm=CreatePopupMenu();
			mii.cbSize=sizeof(mii);
			mii.fMask=MIIM_TYPE|MIIM_ID;
			mii.fType=MFT_STRING;
			mii.dwTypeData="%&phatom_file%";
			mii.cch=strlen(mii.dwTypeData);
			mii.wID=1;
			InsertMenuItem(hm, 0, TRUE, &mii);

			mii.dwTypeData="%&remove_file%";
			mii.cch=strlen(mii.dwTypeData);
			mii.wID=2;
			InsertMenuItem(hm, 1, TRUE, &mii);
			
			mii.dwTypeData="%&free_file%";
			mii.cch=strlen(mii.dwTypeData);
			mii.wID=3;
			InsertMenuItem(hm, 2, TRUE, &mii);

			switch (TrackPopupMenu(hm, TPM_LEFTALIGN|TPM_RETURNCMD|TPM_LEFTBUTTON, pt.x, pt.y, 0, hDlg, NULL)) {
			case 1:
				SetDlgItemText(hDlg, IDC_EDIT1, "%phatom_file%");
				break;
			case 2:
				SetDlgItemText(hDlg, IDC_EDIT1, "%remove_file%");
				break;
			case 3:
				SetDlgItemText(hDlg, IDC_EDIT1, "%free_file%");
				break;
			}
			return 0;
		case IDC_BUTTON1:
			OpenFileName.lStructSize		= sizeof(OPENFILENAME);
			OpenFileName.lpstrTitle			= "Browse for file...";
			OpenFileName.hwndOwner			= GetFocus();
			OpenFileName.hInstance			= hI;
			OpenFileName.lpstrFilter		= "All files (*.*)\0*.*\0";
			OpenFileName.lpstrCustomFilter	= NULL;
			OpenFileName.nMaxCustFilter		= 0;
			OpenFileName.nFilterIndex		= 0;
			OpenFileName.lpstrFile			= buf;
			OpenFileName.nMaxFile			= _MAX_PATH;
			OpenFileName.lpstrFileTitle		= NULL;
			OpenFileName.nMaxFileTitle		= 0;
			OpenFileName.lpstrInitialDir	= NULL;
			OpenFileName.nFileOffset		= 0;
			OpenFileName.nFileExtension		= 0;
			OpenFileName.lpstrDefExt		= NULL;
			OpenFileName.Flags				= OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_FILEMUSTEXIST;
			
			if (!GetOpenFileName(&OpenFileName))
				return 0;

			SetDlgItemText(hDlg, IDC_EDIT1, OpenFileName.lpstrFile);
			return 0;
		case IDC_CHECK1:
			if (IsDlgButtonChecked(hDlg, IDC_CHECK1)) {
				ShowWindow(GetDlgItem(hDlg, IDC_EDIT4), SW_SHOW);
				ShowWindow(GetDlgItem(hDlg, IDC_EDIT5), SW_SHOW);
				ShowWindow(GetDlgItem(hDlg, IDC_EDIT6), SW_SHOW);
				ShowWindow(GetDlgItem(hDlg, IDC_EDIT7), SW_SHOW);
				ShowWindow(GetDlgItem(hDlg, IDC_EDIT8), SW_SHOW);
				ShowWindow(GetDlgItem(hDlg, IDC_EDIT9), SW_SHOW);
				ShowWindow(GetDlgItem(hDlg, IDC_STATIC1), SW_SHOW);
				ShowWindow(GetDlgItem(hDlg, IDC_STATIC2), SW_SHOW);
				ShowWindow(GetDlgItem(hDlg, IDC_STATIC3), SW_SHOW);
				ShowWindow(GetDlgItem(hDlg, IDC_STATIC4), SW_SHOW);
				ShowWindow(GetDlgItem(hDlg, IDC_STATIC9), SW_SHOW);
				ShowWindow(GetDlgItem(hDlg, IDC_STATIC10), SW_SHOW);
			} else {
				ShowWindow(GetDlgItem(hDlg, IDC_EDIT4), SW_HIDE);
				ShowWindow(GetDlgItem(hDlg, IDC_EDIT5), SW_HIDE);
				ShowWindow(GetDlgItem(hDlg, IDC_EDIT6), SW_HIDE);
				ShowWindow(GetDlgItem(hDlg, IDC_EDIT7), SW_HIDE);
				ShowWindow(GetDlgItem(hDlg, IDC_EDIT8), SW_HIDE);
				ShowWindow(GetDlgItem(hDlg, IDC_EDIT9), SW_HIDE);
				ShowWindow(GetDlgItem(hDlg, IDC_STATIC1), SW_HIDE);
				ShowWindow(GetDlgItem(hDlg, IDC_STATIC2), SW_HIDE);
				ShowWindow(GetDlgItem(hDlg, IDC_STATIC3), SW_HIDE);
				ShowWindow(GetDlgItem(hDlg, IDC_STATIC4), SW_HIDE);
				ShowWindow(GetDlgItem(hDlg, IDC_STATIC9), SW_HIDE);
				ShowWindow(GetDlgItem(hDlg, IDC_STATIC10), SW_HIDE);
			}
			return 0;
		}
	}
	return 0;
}

BOOL CALLBACK ChFileDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg) {
	case WM_INITDIALOG:
		SetDlgItemText(hDlg, IDC_EDIT1, instfile.fg[curfg]->fgi[curfgi]->source);
		SetDlgItemText(hDlg, IDC_EDIT2, instfile.fg[curfg]->fgi[curfgi]->target);
		SetDlgItemText(hDlg, IDC_EDIT4, instfile.fg[curfg]->fgi[curfgi]->lname);
		SetDlgItemText(hDlg, IDC_EDIT5, instfile.fg[curfg]->fgi[curfgi]->ltargetdir);
		SetDlgItemText(hDlg, IDC_EDIT6, instfile.fg[curfg]->fgi[curfgi]->ldescr);
		SetDlgItemText(hDlg, IDC_EDIT7, instfile.fg[curfg]->fgi[curfgi]->liconpath);
		SetDlgItemText(hDlg, IDC_EDIT9, instfile.fg[curfg]->fgi[curfgi]->lwrkdir);
		SetDlgItemInt(hDlg, IDC_EDIT8, instfile.fg[curfg]->fgi[curfgi]->liconnum, FALSE);
		CheckDlgButton(hDlg, IDC_CHECK1, instfile.fg[curfg]->fgi[curfgi]->link);
		SendMessage(hDlg, WM_COMMAND, MAKEWPARAM(IDC_CHECK1, 0), 0);
		return TRUE;
	case WM_DRAWITEM:
		if (!DrawButton(hDlg, (UINT)wParam, (DRAWITEMSTRUCT*)lParam))
			return TRUE;
		else
			return 0;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDOK:
			GetDlgItemText(hDlg, IDC_EDIT1, instfile.fg[curfg]->fgi[curfgi]->source, _MAX_PATH);
			if (lastchar(instfile.fg[curfg]->fgi[curfgi]->source)=='\\')
				lastchar(instfile.fg[curfg]->fgi[curfgi]->source)='\0';
			GetDlgItemText(hDlg, IDC_EDIT2, instfile.fg[curfg]->fgi[curfgi]->target, _MAX_PATH);
			if (lastchar(instfile.fg[curfg]->fgi[curfgi]->target)=='\\')
				lastchar(instfile.fg[curfg]->fgi[curfgi]->target)='\0';
			GetDlgItemText(hDlg, IDC_EDIT4, instfile.fg[curfg]->fgi[curfgi]->lname, 64);
			if (lastchar(instfile.fg[curfg]->fgi[curfgi]->lname)=='\\')
				lastchar(instfile.fg[curfg]->fgi[curfgi]->lname)='\0';
			GetDlgItemText(hDlg, IDC_EDIT5, instfile.fg[curfg]->fgi[curfgi]->ltargetdir, 128);
			if (lastchar(instfile.fg[curfg]->fgi[curfgi]->ltargetdir)=='\\')
				lastchar(instfile.fg[curfg]->fgi[curfgi]->ltargetdir)='\0';
			GetDlgItemText(hDlg, IDC_EDIT6, instfile.fg[curfg]->fgi[curfgi]->ldescr, 64);
			GetDlgItemText(hDlg, IDC_EDIT7, instfile.fg[curfg]->fgi[curfgi]->liconpath, _MAX_PATH);
			if (lastchar(instfile.fg[curfg]->fgi[curfgi]->liconpath)=='\\')
				lastchar(instfile.fg[curfg]->fgi[curfgi]->liconpath)='\0';
			GetDlgItemText(hDlg, IDC_EDIT9, instfile.fg[curfg]->fgi[curfgi]->lwrkdir, _MAX_DIR+_MAX_DRIVE);
			if (lastchar(instfile.fg[curfg]->fgi[curfgi]->lwrkdir)=='\\')
				lastchar(instfile.fg[curfg]->fgi[curfgi]->lwrkdir)='\0';
			instfile.fg[curfg]->fgi[curfgi]->liconnum=GetDlgItemInt(hDlg, IDC_EDIT8, NULL, FALSE);
			instfile.fg[curfg]->fgi[curfgi]->link=IsDlgButtonChecked(hDlg, IDC_CHECK1);
			EndDialog(hDlg, 0);
			return 0;
		case IDCANCEL:
			EndDialog(hDlg, 1);
			return 0;
		case IDC_BUTTON2:
			GetDlgItemText(hDlg, IDC_EDIT1, buf, _MAX_PATH);
			SetDlgItemText(hDlg, IDC_EDIT2, buf);
			return 0;
		case IDC_BUTTON6:
			GetCursorPos(&pt);
			hm=CreatePopupMenu();
			mii.cbSize=sizeof(mii);
			mii.fMask=MIIM_TYPE|MIIM_ID;
			mii.fType=MFT_STRING;
			mii.dwTypeData="%&phatom_file%";
			mii.cch=strlen(mii.dwTypeData);
			mii.wID=1;
			InsertMenuItem(hm, 0, TRUE, &mii);

			mii.dwTypeData="%&remove_file%";
			mii.cch=strlen(mii.dwTypeData);
			mii.wID=2;
			InsertMenuItem(hm, 1, TRUE, &mii);
			
			mii.dwTypeData="%&free_file%";
			mii.cch=strlen(mii.dwTypeData);
			mii.wID=3;
			InsertMenuItem(hm, 2, TRUE, &mii);

			switch (TrackPopupMenu(hm, TPM_LEFTALIGN|TPM_RETURNCMD|TPM_LEFTBUTTON, pt.x, pt.y, 0, hDlg, NULL)) {
			case 1:
				SetDlgItemText(hDlg, IDC_EDIT1, "%phatom_file%");
				break;
			case 2:
				SetDlgItemText(hDlg, IDC_EDIT1, "%remove_file%");
				break;
			case 3:
				SetDlgItemText(hDlg, IDC_EDIT1, "%free_file%");
				break;
			}
			return 0;
		case IDC_BUTTON1:
			OpenFileName.lStructSize		= sizeof(OPENFILENAME);
			OpenFileName.lpstrTitle			= "Browse for file...";
			OpenFileName.hwndOwner			= GetFocus();
			OpenFileName.hInstance			= hI;
			OpenFileName.lpstrFilter		= "All files (*.*)\0*.*\0";
			OpenFileName.lpstrCustomFilter	= NULL;
			OpenFileName.nMaxCustFilter		= 0;
			OpenFileName.nFilterIndex		= 0;
			OpenFileName.lpstrFile			= buf;
			OpenFileName.nMaxFile			= _MAX_PATH;
			OpenFileName.lpstrFileTitle		= NULL;
			OpenFileName.nMaxFileTitle		= 0;
			OpenFileName.lpstrInitialDir	= NULL;
			OpenFileName.nFileOffset		= 0;
			OpenFileName.nFileExtension		= 0;
			OpenFileName.lpstrDefExt		= NULL;
			OpenFileName.Flags				= OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_FILEMUSTEXIST;
			
			if (!GetOpenFileName(&OpenFileName))
				return 0;

			SetDlgItemText(hDlg, IDC_EDIT1, OpenFileName.lpstrFile);
			return 0;
		case IDC_CHECK1:
			if (IsDlgButtonChecked(hDlg, IDC_CHECK1)) {
				ShowWindow(GetDlgItem(hDlg, IDC_EDIT4), SW_SHOW);
				ShowWindow(GetDlgItem(hDlg, IDC_EDIT5), SW_SHOW);
				ShowWindow(GetDlgItem(hDlg, IDC_EDIT6), SW_SHOW);
				ShowWindow(GetDlgItem(hDlg, IDC_EDIT7), SW_SHOW);
				ShowWindow(GetDlgItem(hDlg, IDC_EDIT8), SW_SHOW);
				ShowWindow(GetDlgItem(hDlg, IDC_EDIT9), SW_SHOW);
				ShowWindow(GetDlgItem(hDlg, IDC_STATIC1), SW_SHOW);
				ShowWindow(GetDlgItem(hDlg, IDC_STATIC2), SW_SHOW);
				ShowWindow(GetDlgItem(hDlg, IDC_STATIC3), SW_SHOW);
				ShowWindow(GetDlgItem(hDlg, IDC_STATIC4), SW_SHOW);
				ShowWindow(GetDlgItem(hDlg, IDC_STATIC9), SW_SHOW);
				ShowWindow(GetDlgItem(hDlg, IDC_STATIC10), SW_SHOW);
			} else {
				ShowWindow(GetDlgItem(hDlg, IDC_EDIT4), SW_HIDE);
				ShowWindow(GetDlgItem(hDlg, IDC_EDIT5), SW_HIDE);
				ShowWindow(GetDlgItem(hDlg, IDC_EDIT6), SW_HIDE);
				ShowWindow(GetDlgItem(hDlg, IDC_EDIT7), SW_HIDE);
				ShowWindow(GetDlgItem(hDlg, IDC_EDIT8), SW_HIDE);
				ShowWindow(GetDlgItem(hDlg, IDC_EDIT9), SW_HIDE);
				ShowWindow(GetDlgItem(hDlg, IDC_STATIC1), SW_HIDE);
				ShowWindow(GetDlgItem(hDlg, IDC_STATIC2), SW_HIDE);
				ShowWindow(GetDlgItem(hDlg, IDC_STATIC3), SW_HIDE);
				ShowWindow(GetDlgItem(hDlg, IDC_STATIC4), SW_HIDE);
				ShowWindow(GetDlgItem(hDlg, IDC_STATIC9), SW_HIDE);
				ShowWindow(GetDlgItem(hDlg, IDC_STATIC10), SW_HIDE);
			}
			return 0;
		}
	}
	return 0;
}

BOOL CALLBACK GetNameDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg) {
	case WM_INITDIALOG:
		SetDlgItemText(hDlg, IDC_EDIT1, name);
		return TRUE;
	case WM_DRAWITEM:
		if (!DrawButton(hDlg, (UINT)wParam, (DRAWITEMSTRUCT*)lParam))
			return TRUE;
		else
			return 0;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDOK:
			GetDlgItemText(hDlg,IDC_EDIT1, name, 256);
			EndDialog(hDlg, 0);
			return 0;
		}
	}
	return 0;
}

BOOL CALLBACK RegGroupsDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	int i, j, k, x;

	switch (uMsg) {
	case WM_INITDIALOG:
		instfile.putrtolistbox(GetDlgItem(hDlg, IDC_LIST1));
		instfile.putrctolistbox(GetDlgItem(hDlg, IDC_LIST2));
		return TRUE;
	case WM_CLOSE:
		SendMessage(hDlg, WM_COMMAND, MAKEWPARAM(IDOK, 0), 0);
		return 0;
	case WM_DRAWITEM:
		if (!DrawButton(hDlg, (UINT)wParam, (DRAWITEMSTRUCT*)lParam))
			return TRUE;
		else
			return 0;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDOK:
			EndDialog(hDlg, 0);
			return 0;
		case IDCANCEL:
			EndDialog(hDlg, 1);
			return 0;
		case IDC_LIST1:
			if (HIWORD(wParam)==LBN_SELCHANGE) {
				instfile.curr=SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCURSEL, 0, 0);
				instfile.putrtolistbox(GetDlgItem(hDlg, IDC_LIST1));
				instfile.putrctolistbox(GetDlgItem(hDlg, IDC_LIST2));
			}
			if (HIWORD(wParam)==LBN_DBLCLK) {
				currg=SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCURSEL, 0, 0);
				strcpy(name, instfile.rg[currg]->name);
				DialogBox(hI, "ADDITEM", hDlg, (DLGPROC)GetNameDlgProc);
				strcpy(instfile.rg[currg]->name, name);
				instfile.putrtolistbox(GetDlgItem(hDlg, IDC_LIST1));
			}
			return 0;
		case IDC_LIST2:
			if (HIWORD(wParam)==LBN_DBLCLK) {
				currg=SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCURSEL, 0, 0);
				x=SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCOUNT, 0, 0);
				for (i=0; i<x; i++) {
					if (SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETSEL, (WPARAM)i, 0)>0) {
						currgi=SendDlgItemMessage(hDlg, IDC_LIST2, LB_GETCURSEL, 0, 0);
						break;
					}
				}
				
				if (!DialogBox(hI, "ADDREG", hDlg, (DLGPROC)ChRegDlgProc)) {
					instfile.putrtolistbox(GetDlgItem(hDlg, IDC_LIST1));
					instfile.putrctolistbox(GetDlgItem(hDlg, IDC_LIST2));
				}
			}
			return 0;
		case IDC_BUTTON2:
			j=instfile.rg[currg]->rgino;
			k=0;
			for (i=0; i<j; i++)
			{
				if (SendDlgItemMessage(hDlg, IDC_LIST2, LB_GETSEL, i, 0)>0)
				{
					instfile.remrfromgrp(SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCURSEL, 0, 0), i-k);
					k++;
				}
			}
			instfile.putrtolistbox(GetDlgItem(hDlg, IDC_LIST1));
			instfile.putrctolistbox(GetDlgItem(hDlg, IDC_LIST2));
			return 0;
		case IDC_BUTTON7:
			strcpy(name, "");
			DialogBox(hI, "ADDITEM", hDlg, (DLGPROC)GetNameDlgProc);
			instfile.newrgrp(name);
			instfile.putrtolistbox(GetDlgItem(hDlg, IDC_LIST1));
			instfile.putrctolistbox(GetDlgItem(hDlg, IDC_LIST2));
			return 0;

		case IDC_BUTTON9:
			j=SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCURSEL, 0, 0);
			for (i=0; i<instfile.itno; i++) {
				for (k=0; k<instfile.it[i]->rgno; k++) {
					if (instfile.it[i]->rg[k]==j) {
						MsgBox(MB_OK|MB_ICONSTOP, "Install type '%s' contains registry actions group '%s'! You can't delete it until you remove it from that install type", instfile.it[i]->name, instfile.rg[j]->name);
						return 0;
					}
				}
			}
			instfile.remrgrp(j);
			instfile.putrtolistbox(GetDlgItem(hDlg, IDC_LIST1));
			instfile.putrctolistbox(GetDlgItem(hDlg, IDC_LIST2));
			SendDlgItemMessage(hDlg, IDC_LIST1, LB_SETCURSEL, (WPARAM)0, 0);
			instfile.curr=currg=0;
			return 0;
		case IDC_BUTTON1:
			if (instfile.rgno>0) {
				currg=SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCURSEL, 0, 0);
				instfile.curr=SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCURSEL, 0, 0);
				if (!DialogBox(hI, "ADDREG", hDlg, (DLGPROC)AddRegDlgProc)) {
					instfile.putrtolistbox(GetDlgItem(hDlg, IDC_LIST1));
					instfile.putrctolistbox(GetDlgItem(hDlg, IDC_LIST2));
				}
			}
			return 0;
		case IDC_BUTTON4:
			SendDlgItemMessage(hDlg, IDC_LIST2, LB_SETSEL, (WPARAM)TRUE, (LPARAM)-1);
			return 0;
		case IDC_BUTTON10:
			currg=SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCURSEL, 0, 0);

			for (i=0; i<instfile.rg[curfg]->rgino; i++) {
				if (SendDlgItemMessage(hDlg, IDC_LIST2, LB_GETSEL, (WPARAM)i, (LPARAM)0)>0)
					SendDlgItemMessage(hDlg, IDC_LIST2, LB_SETSEL, (WPARAM)FALSE, (LPARAM)i);
				else
					SendDlgItemMessage(hDlg, IDC_LIST2, LB_SETSEL, (WPARAM)TRUE, (LPARAM)i);
			}
			return 0;
		}
	}
	return 0;
}

BOOL CALLBACK AddRegDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	char *combotxt[6]={"HKEY_CLASSES_ROOT", "HKEY_CURRENT_USER", "HKEY_LOCAL_MACHINE", "HKEY_USERS", "HKEY_CURRENT_CONFIG", "HKEY_DYN_DATA"};
	int i;

	switch (uMsg) {
	case WM_INITDIALOG:
		for (i=0; i<6; i++)
			SendDlgItemMessage(hDlg, IDC_COMBO1, CB_ADDSTRING, (WPARAM)0, (LPARAM)combotxt[i]);
		return TRUE;
	case WM_CLOSE:
		SendMessage(hDlg, WM_COMMAND, MAKEWPARAM(IDOK, 0), 0);
		return 0;
	case WM_DRAWITEM:
		if (!DrawButton(hDlg, (UINT)wParam, (DRAWITEMSTRUCT*)lParam))
			return TRUE;
		else
			return 0;
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDOK:
			if (SendDlgItemMessage(hDlg, IDC_COMBO1, CB_GETCURSEL, 0, 0)==CB_ERR) {
				MessageBeep(0xFFFFFFFF);
				return 0;
			}
			if (instfile.addrtogrp()) {
				MsgBox(MB_OK|MB_ICONWARNING, "Out of memory or you reached the maximum count of items in single file group!");
				return 1;
			}
			instfile.rg[currg]->rgi[instfile.rg[currg]->rgino-1]->root=SendDlgItemMessage(hDlg, IDC_COMBO1, CB_GETCURSEL, 0, 0);
			GetDlgItemText(hDlg, IDC_EDIT1, instfile.rg[currg]->rgi[instfile.rg[currg]->rgino-1]->path, 256);
			if (lastchar(instfile.rg[currg]->rgi[instfile.rg[currg]->rgino-1]->path)=='\\')
				lastchar(instfile.rg[currg]->rgi[instfile.rg[currg]->rgino-1]->path)='\0';
			GetDlgItemText(hDlg, IDC_EDIT2, instfile.rg[currg]->rgi[instfile.rg[currg]->rgino-1]->item, 64);
			GetDlgItemText(hDlg, IDC_EDIT3, instfile.rg[currg]->rgi[instfile.rg[currg]->rgino-1]->value, 256);
			EndDialog(hDlg, 0);
			return 0;
		case IDCANCEL:
			EndDialog(hDlg, 1);
			return 0;
		case IDC_BUTTON1:
			GetCursorPos(&pt);
			hm=CreatePopupMenu();
			mii.cbSize=sizeof(mii);
			mii.fMask=MIIM_TYPE|MIIM_ID;
			mii.fType=MFT_STRING;
			mii.dwTypeData="%&phatom_regentry%";
			mii.cch=strlen(mii.dwTypeData);
			mii.wID=1;
			InsertMenuItem(hm, 0, TRUE, &mii);

			mii.dwTypeData="%&remove_regentry%";
			mii.cch=strlen(mii.dwTypeData);
			mii.wID=2;
			InsertMenuItem(hm, 1, TRUE, &mii);

			switch (TrackPopupMenu(hm, TPM_LEFTALIGN|TPM_RETURNCMD|TPM_LEFTBUTTON, pt.x, pt.y, 0, hDlg, NULL)) {
			case 1:
				SetDlgItemText(hDlg, IDC_EDIT3, "%phatom_regentry%");
				break;
			case 2:
				SetDlgItemText(hDlg, IDC_EDIT3, "%remove_regentry%");
				break;
			}
			return 0;
		}
	}
	return 0;
}

BOOL CALLBACK ChRegDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	char *combotxt[6]={"HKEY_CLASSES_ROOT", "HKEY_CURRENT_USER", "HKEY_LOCAL_MACHINE", "HKEY_USERS", "HKEY_CURRENT_CONFIG", "HKEY_DYN_DATA"};
	int i;
	char tmp[256];

	switch (uMsg) {
	case WM_INITDIALOG:
		for (i=0; i<6; i++)
			SendDlgItemMessage(hDlg, IDC_COMBO1, CB_ADDSTRING, (WPARAM)0, (LPARAM)combotxt[i]);
		
		SetDlgItemText(hDlg, IDC_EDIT1, instfile.rg[currg]->rgi[currgi]->path);
		SetDlgItemText(hDlg, IDC_EDIT2, instfile.rg[currg]->rgi[currgi]->item);
		SetDlgItemText(hDlg, IDC_EDIT3, instfile.rg[currg]->rgi[currgi]->value);
		SendDlgItemMessage(hDlg, IDC_COMBO1, CB_SETCURSEL, (WPARAM)instfile.rg[currg]->rgi[currgi]->root, 0);
		return TRUE;
	case WM_CLOSE:
		SendMessage(hDlg, WM_COMMAND, MAKEWPARAM(IDOK, 0), 0);
		return 0;
	case WM_DRAWITEM:
		if (!DrawButton(hDlg, (UINT)wParam, (DRAWITEMSTRUCT*)lParam))
			return TRUE;
		else
			return 0;
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDOK:
			if (SendDlgItemMessage(hDlg, IDC_COMBO1, CB_GETCURSEL, 0, 0)==CB_ERR) {
				MessageBeep(0xFFFFFFFF);
				return 0;
			}
			GetDlgItemText(hDlg, IDC_EDIT1, tmp, 256);
			if (!strcmpi(tmp, "")) {
				MessageBeep(0xFFFFFFFF);
				return 0;
			}
			instfile.rg[currg]->rgi[currgi]->root=SendDlgItemMessage(hDlg, IDC_COMBO1, CB_GETCURSEL, 0, 0);
			GetDlgItemText(hDlg, IDC_EDIT1, instfile.rg[currg]->rgi[currgi]->path, 256);
			GetDlgItemText(hDlg, IDC_EDIT2, instfile.rg[currg]->rgi[currgi]->item, 64);
			GetDlgItemText(hDlg, IDC_EDIT3, instfile.rg[currg]->rgi[currgi]->value, 256);
			EndDialog(hDlg, 0);
			return 0;
		case IDCANCEL:
			EndDialog(hDlg, 1);
			return 0;
		case IDC_BUTTON1:
			GetCursorPos(&pt);
			hm=CreatePopupMenu();
			mii.cbSize=sizeof(mii);
			mii.fMask=MIIM_TYPE|MIIM_ID;
			mii.fType=MFT_STRING;
			mii.dwTypeData="%&phatom_regentry%";
			mii.cch=strlen(mii.dwTypeData);
			mii.wID=1;
			InsertMenuItem(hm, 0, TRUE, &mii);

			mii.dwTypeData="%&remove_regentry%";
			mii.cch=strlen(mii.dwTypeData);
			mii.wID=2;
			InsertMenuItem(hm, 1, TRUE, &mii);
			

			switch (TrackPopupMenu(hm, TPM_LEFTALIGN|TPM_RETURNCMD|TPM_LEFTBUTTON, pt.x, pt.y, 0, hDlg, NULL)) {
			case 1:
				SetDlgItemText(hDlg, IDC_EDIT3, "%phatom_regentry%");
				break;
			case 2:
				SetDlgItemText(hDlg, IDC_EDIT3, "%remove_regentry%");
				break;
			}
			return 0;
		}
	}
	return 0;
}

BOOL CALLBACK InstTypesDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	int i;

	switch (uMsg) {
	case WM_INITDIALOG:
		instfile.putittolistbox(GetDlgItem(hDlg, IDC_LIST1), GetDlgItem(hDlg, IDC_LIST2), GetDlgItem(hDlg, IDC_LIST3));
		if (instfile.itno!=0) {
			CheckDlgButton(hDlg, IDC_CHECK5, instfile.it[instfile.curit]->fgcust);
			CheckDlgButton(hDlg, IDC_CHECK6, instfile.it[instfile.curit]->rgcust);
		}
		return TRUE;
	case WM_CLOSE:
		SendMessage(hDlg, WM_COMMAND, MAKEWPARAM(IDOK, 0), 0);
		return 0;
	case WM_DRAWITEM:
		if (!DrawButton(hDlg, (UINT)wParam, (DRAWITEMSTRUCT*)lParam))
			return TRUE;
		else
			return 0;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_LIST1:
			if (HIWORD(wParam)==LBN_SELCHANGE) {
				instfile.curit=SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCURSEL, 0, 0);
				instfile.putittolistbox(GetDlgItem(hDlg, IDC_LIST1), GetDlgItem(hDlg, IDC_LIST2), GetDlgItem(hDlg, IDC_LIST3));
				CheckDlgButton(hDlg, IDC_CHECK5, instfile.it[instfile.curit]->fgcust);
				CheckDlgButton(hDlg, IDC_CHECK6, instfile.it[instfile.curit]->rgcust);
			}
			if (HIWORD(wParam)==LBN_DBLCLK) {
				curit=SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCURSEL, 0, 0);
				strcpy(name, instfile.it[instfile.curit]->name);
				DialogBox(hI, "ADDITEM", hDlg, (DLGPROC)GetNameDlgProc);
				strcpy(instfile.it[curit]->name, name);
				instfile.putittolistbox(GetDlgItem(hDlg, IDC_LIST1), GetDlgItem(hDlg, IDC_LIST2), GetDlgItem(hDlg, IDC_LIST3));
			}
			return 0;
		case IDOK:
			EndDialog(hDlg, 0);
			return 0;
		case IDCANCEL:
			EndDialog(hDlg, 1);
			return 0;
		case IDC_CHECK5:
			instfile.it[instfile.curit]->fgcust=IsDlgButtonChecked(hDlg, IDC_CHECK5);
			return 0;
		case IDC_CHECK6:
			instfile.it[instfile.curit]->rgcust=IsDlgButtonChecked(hDlg, IDC_CHECK6);
			return 0;
		case IDC_BUTTON7:
			strcpy(name, "");
			DialogBox(hI, "ADDITEM", hDlg, (DLGPROC)GetNameDlgProc);
			instfile.newitype(name);
			instfile.putittolistbox(GetDlgItem(hDlg, IDC_LIST1), GetDlgItem(hDlg, IDC_LIST2), GetDlgItem(hDlg, IDC_LIST3));
			return 0;
		case IDC_BUTTON9:
			instfile.remitype(SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCURSEL, 0, 0));
			instfile.putittolistbox(GetDlgItem(hDlg, IDC_LIST1), GetDlgItem(hDlg, IDC_LIST2), GetDlgItem(hDlg, IDC_LIST3));
			return 0;
		case IDC_BUTTON1:
			if (instfile.itno<=0)
				return 0;
			i=DialogBox(hI, "ADDFR", hDlg, (DLGPROC)FIAddDlgProc);
			if (i==CB_ERR)
				return 0;
			instfile.addfgtoit(i);
			instfile.putittolistbox(GetDlgItem(hDlg, IDC_LIST1), GetDlgItem(hDlg, IDC_LIST2), GetDlgItem(hDlg, IDC_LIST3));
			return 0;
		case IDC_BUTTON3:
			if (instfile.itno<=0)
				return 0;
			i=DialogBox(hI, "ADDFR", hDlg, (DLGPROC)RIAddDlgProc);
			if (i==CB_ERR)
				return 0;
			instfile.addrgtoit(i);
			instfile.putittolistbox(GetDlgItem(hDlg, IDC_LIST1), GetDlgItem(hDlg, IDC_LIST2), GetDlgItem(hDlg, IDC_LIST3));
			return 0;
		case IDC_BUTTON2:
			if (instfile.itno<=0)
				return 0;
			i=SendDlgItemMessage(hDlg, IDC_LIST2, LB_GETCURSEL, 0, 0);
			instfile.remfgfromit(i);
			instfile.putittolistbox(GetDlgItem(hDlg, IDC_LIST1), GetDlgItem(hDlg, IDC_LIST2), GetDlgItem(hDlg, IDC_LIST3));
			return 0;
		case IDC_BUTTON6:
			if (instfile.itno<=0)
				return 0;
			i=SendDlgItemMessage(hDlg, IDC_LIST3, LB_GETCURSEL, 0, 0);
			instfile.remrgfromit(i);
			instfile.putittolistbox(GetDlgItem(hDlg, IDC_LIST1), GetDlgItem(hDlg, IDC_LIST2), GetDlgItem(hDlg, IDC_LIST3));
			return 0;
		}
	}
	return 0;
}


BOOL CALLBACK FIAddDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	int i;

	switch (uMsg) {
	case WM_INITDIALOG:
		for (i=0; i<instfile.fgno; i++)
			SendDlgItemMessage(hDlg, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM)instfile.fg[i]->name);
		return TRUE;
	case WM_CLOSE:
		SendMessage(hDlg, WM_COMMAND, MAKEWPARAM(IDOK, 0), 0);
		return 0;
	case WM_DRAWITEM:
		if (!DrawButton(hDlg, (UINT)wParam, (DRAWITEMSTRUCT*)lParam))
			return TRUE;
		else
			return 0;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDOK:
			EndDialog(hDlg, SendDlgItemMessage(hDlg, IDC_COMBO1, CB_GETCURSEL, 0, 0));
			return 0;
		case IDCANCEL:
			EndDialog(hDlg, CB_ERR);
			return 0;
		}
	}
	return 0;
}

BOOL CALLBACK RIAddDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	int i;

	switch (uMsg) {
	case WM_INITDIALOG:
		for (i=0; i<instfile.rgno; i++)
			SendDlgItemMessage(hDlg, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM)instfile.rg[i]->name);
		return TRUE;
	case WM_CLOSE:
		SendMessage(hDlg, WM_COMMAND, MAKEWPARAM(IDOK, 0), 0);
		return 0;
	case WM_DRAWITEM:
		if (!DrawButton(hDlg, (UINT)wParam, (DRAWITEMSTRUCT*)lParam))
			return TRUE;
		else
			return 0;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDOK:
			EndDialog(hDlg, SendDlgItemMessage(hDlg, IDC_COMBO1, CB_GETCURSEL, 0, 0));
			return 0;
		case IDCANCEL:
			EndDialog(hDlg, CB_ERR);
			return 0;
		}
	}
	return 0;
}