/*
    CoolSetup installation system
    Copyright (C) 2001-2002 Andrej Krutak

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "../shared/instclass.h"
#include "./instclass.h"

installfile_installer::installfile_installer()
{
	initialize();
}

installfile_installer::~installfile_installer()
{
	uninitialize();
}

int installfile_installer::save(char *path)
{
	return 1;
}

int installfile_installer::load(char *path)
{
	FILE *file;
	char buf[1024];
	int i, j, fno, rno, ino, ffgino, rrgino, ifgno, irgno;
	file=fopen(path, "rb");

	for (i=0; i<fgno; i++)
		delete fg[i];
	for (i=0; i<rgno; i++)
		delete rg[i];
	for (i=0; i<itno; i++)
		delete it[i];
	itno=fgno=rgno=0;
	for (i=0; i<32; i++) {
		fg[i]=NULL;
		rg[i]=NULL;
		it[i]=NULL;
	}

	curr=curf=curit=0;
	compressionstrength=6;
	ajc=1;

	if (file==NULL) {
		MessageBox(GetFocus(), projpath, "Can't open file", MB_OK);
		return 1;
	}

	ini_getnextline(file, buf);	
	if (!strcmp(buf, "CoolSetupProject 1")) {
		ini_getnextline(file, outputpath);
		ini_getnextline(file, windowcaption);
		ini_getnextline(file, bigcaption);
		ini_getnextline(file, copyright);
		ini_getnextline(file, uninstkey);
		ini_getnextline(file, defprogdir);
		parse_path(defprogdir);
		ini_getnextline(file, defmenudir);
		ini_getnextline(file, readmefile);
		ini_getnextline(file, licensefile);
		ini_getnextline(file, execinst);
		ini_getnextline(file, execuninst);
		showbgwin=ini_getnextint(file);
		gofullscreen=ini_getnextint(file);
		showwelcome=ini_getnextint(file);
		showlicense=ini_getnextint(file);
		showreadme=ini_getnextint(file);
		showtarget=ini_getnextint(file);
		enableuninstallation=ini_getnextint(file);
		compressionstrength=ini_getnextint(file);
		overwriteprompt=ini_getnextint(file);
		progdircustom=ini_getnextint(file);
		menudircustom=ini_getnextint(file);
		topcolor=ini_getnextint(file);
		bottomcolor=ini_getnextint(file);
		ajc=ini_getnextint(file);
		
		fno=ini_getnextint(file);
		rno=ini_getnextint(file);
		ino=ini_getnextint(file);
		
		for (i=0; i<fno; i++) {
			ini_getnextline(file, buf);
			newfgrp(buf);
			if (fg[i]==NULL) {
				MsgBox(MB_OK|MB_ICONSTOP, "Out of memory!");
				fclose(file);
				return 1;
			}
			ffgino=ini_getnextint(file);
			
			for (j=0; j<ffgino; j++) {			
				if (fg[i]->additem()) {
					MsgBox(MB_OK|MB_ICONSTOP, "Out of memory!");
					fclose(file);
					return 1;
				}
				
				ini_getnextline(file, fg[i]->fgi[fg[i]->fgino-1]->source);
				ini_getnextline(file, fg[i]->fgi[fg[i]->fgino-1]->target);
				fg[i]->fgi[fg[i]->fgino-1]->type=ini_getnextint(file);
				fg[i]->fgi[fg[i]->fgino-1]->link=ini_getnextint(file);
				ini_getnextline(file, fg[i]->fgi[fg[i]->fgino-1]->lname);
				ini_getnextline(file, fg[i]->fgi[fg[i]->fgino-1]->ltargetdir);
				ini_getnextline(file, fg[i]->fgi[fg[i]->fgino-1]->liconpath);
				fg[i]->fgi[fg[i]->fgino-1]->liconnum=ini_getnextint(file);
				ini_getnextline(file, fg[i]->fgi[fg[i]->fgino-1]->lwrkdir);
				ini_getnextline(file, fg[i]->fgi[fg[i]->fgino-1]->ldescr);
			}
		}
		for (i=0; i<rno; i++) {
			ini_getnextline(file, buf);
			newrgrp(buf);
			if (rg[i]==NULL) {
				MsgBox(MB_OK|MB_ICONSTOP, "Out of memory!");
				fclose(file);
				return 1;
			}
			rrgino=ini_getnextint(file);
			
			for (j=0; j<rrgino; j++) {			
				if (rg[i]->additem()) {
					MsgBox(MB_OK|MB_ICONSTOP, "Out of memory!");
					fclose(file);
					return 1;
				}
				
				rg[i]->rgi[rg[i]->rgino-1]->root=ini_getnextint(file);
				ini_getnextline(file, rg[i]->rgi[rg[i]->rgino-1]->path);
				ini_getnextline(file, rg[i]->rgi[rg[i]->rgino-1]->item);
				ini_getnextline(file, rg[i]->rgi[rg[i]->rgino-1]->value);
			}
		}
		
		for (i=0; i<ino; i++) {
			ini_getnextline(file, buf);
			newitype(buf);
			if (it[i]==NULL) {
				MsgBox(MB_OK|MB_ICONSTOP, "Out of memory!");
				fclose(file);
				return 1;
			}
			ini_getnextline(file, buf);
			sscanf(buf, "%d %d", &ifgno, &it[i]->fgcust);
			//ifgno=ini_getnextint(file);
			ini_getnextline(file, buf);
			sscanf(buf, "%d %d", &irgno, &it[i]->rgcust);
			//irgno=ini_getnextint(file);
			
			for (j=0; j<ifgno; j++) {			
				if (it[i]->addfilegroup(ini_getnextint(file))) {
					MsgBox(MB_OK|MB_ICONSTOP, "Out of memory!");
					fclose(file);
					return 1;
				}
			}
			
			for (j=0; j<irgno; j++) {			
				if (it[i]->addreggroup(ini_getnextint(file))) {
					MsgBox(MB_OK|MB_ICONSTOP, "Out of memory!");
					fclose(file);
					return 1;
				}
			}
		}
	} else if (!strcmp(buf, "CoolSetupProject 2")) {
	} else {
		MessageBox(GetFocus(), projpath, "Corrupted file or usupported file format!", MB_OK);
		fclose(file);
		return 1;
	}
	fclose(file);
	return 0;
}

int installfile_installer::compile(HWND progress)
{
	//Not supported in installer
	return 1;
}