/*
    CoolSetup installation system
    Copyright (C) 2001-2002 Andrej Krutak

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "./datatypes.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

int MsgBox(unsigned int fuStyle, char *pszFormat, ...);

fileconvnfo_item::fileconvnfo_item(char *s, char *d)
{
	next=NULL;
	src=new char[strlen(s)];
	strcpy(src, s);
	dst=new char[strlen(d)];
	strcpy(dst, d);
}

fileconvnfo_item::~fileconvnfo_item()
{
	delete src;
	delete dst;
}

fileconvnfo::fileconvnfo()
{
	count=0;
	first=NULL;
	last=NULL;
}

fileconvnfo::~fileconvnfo()
{
	int i;
	fileconvnfo_item *nxt, *cur;

	cur=first;

	for (i=0; i<count; i++) {
		nxt=cur->next;
		delete cur;
		cur=nxt;
	}
	
	count=0;
	first=NULL;
	last=NULL;
}

int fileconvnfo::additem(char *src)
{
	char buf[256];
	int i;

	i=getitempos(src);
	if (i!=-1) {
		//Do additional work if there is some...
		return 0;
	}

	strcpy(buf, "");
	sprintf(buf, "%d", count);

	if (count==0) {
		first=new fileconvnfo_item(src, buf);
		last=first;
	}
	else {
		last->next=new fileconvnfo_item(src, buf);
		last=last->next;
	}
	last->next=NULL;
	count++;
	return 0;
}

int fileconvnfo::getitempos(char *src)
{
	int i;
	fileconvnfo_item *cur;

	cur=first;

	for (i=0; i<count; i++) {
		if (!strcmp(src, cur->src))
			return i;
		cur=cur->next;
	}
	return -1;
}

int fileconvnfo::getitem(int index, char *src, char *dst)
{
	int i;
	fileconvnfo_item *cur;

	cur=first;

	for (i=0; i<index; i++) {
		cur=cur->next;
	}

	if (cur==NULL) {
		MsgBox(0, "Out of memory!");
		return 1;
	}
	strcpy(src, cur->src);
	strcpy(dst, cur->dst);
	if (strcmp(src, "%phatom_file%")&&strcmp(src, "%remove_file%")&&strcmp(src, "%free_file%"))
		return 0;
	return 1;
}