/*
    CoolSetup installation system
    Copyright (C) 2001-2002 Andrej Krutak

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "instclass.h"
#include "datatypes.h"

int MsgBox(UINT, char *, ...);
int windows_registry_get_value(HKEY root, char *path, char *entry, int type1, void *datapointer, int sod);

int cs_get_progpath(char *string)
{
	extern HINSTANCE hI;
	char drive[5];
	char path[1024];
	char buffer[_MAX_PATH];

	GetModuleFileName(hI, buffer, 2048);
	_splitpath (buffer, drive, path, NULL, NULL);
	strcpy(string, "\0");
	sprintf(string, "%s%s\0", drive, path);
	return 0;
}

DWORD filetime(char *f, tm_zip *tmzip, DWORD *dt)
{
	int ret = 0;
	{
		FILETIME ftLocal;
		HANDLE hFind;
		WIN32_FIND_DATA  ff32;
		
		hFind = FindFirstFile(f,&ff32);
		if (hFind != INVALID_HANDLE_VALUE) {
			FileTimeToLocalFileTime(&(ff32.ftLastWriteTime),&ftLocal);
			FileTimeToDosDateTime(&ftLocal,((LPWORD)dt)+1,((LPWORD)dt)+0);
			FindClose(hFind);
			ret = 1;
		}
	}
	return ret;
}

filegroupitem::filegroupitem()
{
	strcpy(source, "test");
	strcpy(target, "");
	strcpy(lname, "");
	strcpy(ltargetdir, "");
	strcpy(liconpath, "");
	strcpy(lwrkdir, "");
	strcpy(ldescr, "");
	type=0;
	link=0;
	liconnum=0;
}

reggroupitem::reggroupitem()
{
	strcpy(path, "");
	strcpy(item, "");
	strcpy(value, "");
	root=0;
}

filegroup::filegroup(char *n)
{
	int i;
	for (i=0; i<20000; i++)
		fgi[i]=NULL;
	strcpy(name, n);
	fgino=0;
}

filegroup::filegroup()
{
	int i;
	for (i=0; i<20000; i++)
		fgi[i]=NULL;
	strcpy(name, "");
	fgino=0;
}

filegroup::~filegroup()
{
	int i;
	for (i=0; i<fgino; i++)
		delete fgi[i];
}

int filegroup::additem(void)
{
	fgi[fgino]=new filegroupitem;
	if (fgi[fgino]==NULL)
		return 1;
	fgino++;
	return 0;
}

int filegroup::removeitem(int index)
{
	int i;

	/*delete fgi[index];

	for (i=index; i<fgino; i++)
		fgi[i-1]=fgi[i];

	fgino--;
	if (fgino<0)
		fgino=0;

	MsgBox(0, "%d %d", fgino, index);*/
	delete fgi[index];

	for (i=index+1; i<fgino; i++)
		fgi[i-1]=fgi[i];
	fgino--;
	if (fgino<0)
		fgino=0;
	return 0;
}

int filegroup::puttolistbox(HWND lb)
{
	int i;
	char buf[1024];
	SendMessage(lb, LB_RESETCONTENT, (WPARAM)0, (LPARAM)0);
	SendMessage(lb, LB_SETCOUNT, (WPARAM)fgino, (LPARAM)0);
	for (i=0; i<fgino; i++)
	{
		strcpy(buf, "");
		sprintf(buf, "%d.%s\t (%s)", i+1, fgi[i]->target, fgi[i]->source);
		SendMessage(lb, LB_ADDSTRING, (WPARAM)0, (LPARAM)buf);
	}
	return 0;
}

int filegroup::adddirectory(char* path, int ajc)
{
	WIN32_FIND_DATA wfd;
	int fff=1;
	HANDLE ff;
	char mask[1024];
	char file[_MAX_PATH];

	strcpy(mask, path);
	if (mask[strlen(mask)-1]!='\\')
		strcat(mask, "\\");
	strcat(mask, "*.*");

	for (;;) {
		if (fff) {
			ff=FindFirstFile(mask, &wfd);
			fff=0;
		}

		else
			if (!FindNextFile(ff, &wfd))
				break;

		if (ff==NULL)
			break;

		if (!strcmpi(wfd.cFileName, ".")||!strcmpi(wfd.cFileName, ".."))
			continue;

		if (wfd.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY&&ajc!=0) {
			strcpy(file, path);
			if (file[strlen(file)-1]!='\\')
				strcat(file, "\\");
			strcat(file, wfd.cFileName);
			this->adddirectory(file, ajc);
			continue;
		}
		else if (wfd.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY&&ajc==0)
			continue;
		
		strcpy(file, path);
		if (file[strlen(file)-1]!='\\')
			strcat(file, "\\");
		strcat(file, wfd.cFileName);
		additem();
		strcpy(fgi[fgino-1]->source, file);
		strcpy(file, "%targetprogramdir%");
		if (fgi[fgino-1]->source[rmfp]!='\\')
			strcat(file, "\\");
		strcat(file, &fgi[fgino-1]->source[rmfp]);
		strcpy(fgi[fgino-1]->target, file);
		fgi[fgino-1]->link=0;
	}
	FindClose(ff);
	return 0;
}

reggroup::reggroup(char *n)
{
	int i;
	for (i=0; i<20000; i++)
		rgi[i]=NULL;
	strcpy(name, n);
	rgino=0;
}

reggroup::reggroup()
{
	int i;
	for (i=0; i<20000; i++)
		rgi[i]=NULL;
	strcpy(name, "");
	rgino=0;
}

reggroup::~reggroup()
{
	int i;
	for (i=0; i<rgino; i++)
		delete rgi[i];
}

int reggroup::additem(void)
{
	rgi[rgino]=new reggroupitem;
	rgino++;
	return 0;
}

int reggroup::removeitem(int index)
{
	int i;

	/*delete rgi[index];

	for (i=index; i<rgino; i++)
		rgi[i-1]=rgi[i];

	rgino--;
	if (rgino<0)
		rgino=0;*/

	delete rgi[index];

	for (i=index+1; i<rgino; i++)
		rgi[i-1]=rgi[i];
	rgino--;
	if (rgino<0)
		rgino=0;
	return 0;
}

int reggroup::puttolistbox(HWND lb)
{
	char *rregkey[6]={"HK_CR", "HK_CU", "HK_LM", "HK_U", "HK_CC", "HK_DD"};
	int i;
	char buf[1024];
	SendMessage(lb, LB_RESETCONTENT, (WPARAM)0, (LPARAM)0);
	SendMessage(lb, LB_SETCOUNT, (WPARAM)rgino, (LPARAM)0);
 	for (i=0; i<rgino; i++) {
		strcpy(buf, "");
		sprintf(buf, "%s\\%s:%s=%s", rregkey[rgi[i]->root], rgi[i]->path, rgi[i]->item, rgi[i]->value);
		SendMessage(lb, LB_ADDSTRING, (WPARAM)0, (LPARAM)buf);
	}
	return 0;
}

installtype::installtype(void)
{
	int i;
	for (i=0; i<32; i++) {
		fg[i]=NULL;
		rg[i]=NULL;
	}
	fgno=0;
	rgno=0;
	strcpy(name, "");
}

installtype::installtype(char *nme)
{
	int i;
	for (i=0; i<32; i++)
	{
		fg[i]=NULL;
		rg[i]=NULL;
	}
	fgno=0;
	rgno=0;
	strcpy(name, nme);
}

int installtype::addfilegroup(int nfg)
{
	fg[fgno]=nfg;
	fgno++;
	return 0;
}

int installtype::addreggroup(int nrg)
{
	rg[rgno]=nrg;
	rgno++;
	return 0;
}

int installtype::remfilegroup(int index)
{
	int i;

	fg[index]=NULL;

	for (i=index+1; i<fgno; i++)
		fg[i-1]=fg[i];
	fgno--;
	return 0;
}

int installtype::remreggroup(int index)
{
	int i;

	rg[index]=NULL;

	for (i=index+1; i<rgno; i++)
		rg[i-1]=rg[i];
	rgno--;
	return 0;
}

int installfile_base::newitype(char *name)
{
	it[itno]=new installtype(name);
	itno++;
	curit=itno-1;
	return 0;
}

int installfile_base::remitype(int index)
{
	int i;

	delete it[index];

	for (i=index; i<itno-1; i++)
		it[i]=it[i+1];
	if (itno>=1)
		itno--;
	return 0;
}

int installfile_base::puttolistbox(HWND lb)
{
	int i;

	SendMessage(lb, LB_RESETCONTENT, (WPARAM)0, (LPARAM)0);
	SendMessage(lb, LB_SETCOUNT, (WPARAM)itno, (LPARAM)0);
	for (i=0; i<itno; i++)
		SendMessage(lb, LB_ADDSTRING, (WPARAM)0, (LPARAM)it[i]->name);
	return 0;
}

int installfile_base::remfgrp(int index)
{
	int i;

	delete fg[index];

	for (i=index; i<fgno-1; i++)
		fg[i]=fg[i+1];

	fgno--;
	if (fgno<0)
		fgno=0;
	return 0;
}

int installfile_base::remrgrp(int index)
{
	int i;

	delete rg[index];

	for (i=index; i<rgno-1; i++)
		rg[i]=rg[i+1];

	rgno--;
	if (rgno<0)
		rgno=0;

	return 0;
}

int installfile_base::newfgrp(char *name)
{
	fg[fgno]=new filegroup(name);
	fgno++;
	curf=fgno-1;
	return 0;
}

int installfile_base::newrgrp(char *name)
{
	rg[rgno]=new reggroup(name);
	rgno++;
	curr=rgno-1;
	return 0;
}

int installfile_base::addftogrp(void)
{
	if (fgno!=0)
		fg[curf]->additem();
	return 0;
}

int installfile_base::addrtogrp(void)
{
	if (rgno!=0)
		rg[curr]->additem();
	return 0;
}

int installfile_base::remffromgrp(int f, int index)
{
	if (fgno>f)
		fg[f]->removeitem(index);
	return 0;
}

int installfile_base::remrfromgrp(int f, int index)
{
	if (rgno>f)
		rg[f]->removeitem(index);
	return 0;
}

void installfile_base::initialize(void)
{
	int i;

	itno=fgno=rgno=0;
	for (i=0; i<32; i++)
	{
		fg[i]=NULL;
		rg[i]=NULL;
		it[i]=NULL;
	}

	strcpy(projpath, "");
	curr=curf=curit=0;
	compressionstrength=6;
	ajc=1;
}

installfile_base::installfile_base()
{
	initialize();
}

void installfile_base::uninitialize(void)
{
	int i;
	for (i=0; i<fgno; i++)
		delete fg[i];
	for (i=0; i<rgno; i++)
		delete rg[i];
	for (i=0; i<itno; i++)
		delete it[i];
	fgno=0;
	rgno=0;
	itno=0;
}

installfile_base::~installfile_base()
{
	uninitialize();
}

int ini_skipcomments(FILE *file)
{
	int c;
re:
	if (fgetc(file)==';') {
		for (;c=fgetc(file);) {
			if (c==EOF||c==0x0a)
				break;
		}
		goto re;
	}
	else
		fseek(file, -1, SEEK_CUR);
	return 0;
}

int ini_getnextline(FILE *file, char *buf)
{
	int c, n=0;

	ini_skipcomments(file);
	
	for (;;) {
		c=fgetc(file);
		if (c==EOF||c==0x0a) {
			buf[n]='\0';
			break;
		}
		buf[n]=c;
		n++;
	}
	return 0;
}

unsigned long ini_getnextint(FILE *file)
{
	char buf[1024];
	unsigned long ul;
	ini_getnextline(file, buf);
	sscanf(buf, "%lu", &ul);
	return ul;
}


int installfile_base::putftolistbox(HWND lb)
{
	int i;

	SendMessage(lb, LB_RESETCONTENT, (WPARAM)0, (LPARAM)0);
	SendMessage(lb, LB_SETCOUNT, (WPARAM)fgno, (LPARAM)0);
	for (i=0; i<fgno; i++)
		SendMessage(lb, LB_ADDSTRING, (WPARAM)0, (LPARAM)fg[i]->name);
	SendMessage(lb, LB_SETCURSEL, (WPARAM)curf, 0);
	return 0;
}

int installfile_base::putrtolistbox(HWND lb)
{
	int i;

	SendMessage(lb, LB_RESETCONTENT, (WPARAM)0, (LPARAM)0);
	SendMessage(lb, LB_SETCOUNT, (WPARAM)rgno, (LPARAM)0);
	for (i=0; i<rgno; i++)
		SendMessage(lb, LB_ADDSTRING, (WPARAM)0, (LPARAM)rg[i]->name);
	SendMessage(lb, LB_SETCURSEL, (WPARAM)curr, 0);
	return 0;
}

int installfile_base::putfctolistbox(HWND lb)
{	
	if (fgno!=0) {
		if (fgno==1&&curf==0) {
			fg[curf]->puttolistbox(lb);
			return 0;
		}

		if (curf>=fgno)
			curf=fgno-1;
		if (curf<0)
			return 1;
		fg[curf]->puttolistbox(lb);
	}
	else
		SendMessage(lb, LB_RESETCONTENT, (WPARAM)0, (LPARAM)0);
	return 0;
}

int installfile_base::putrctolistbox(HWND lb)
{	
	if (rgno!=0) {
		if (rgno==1&&curr==0) {
			rg[curr]->puttolistbox(lb);
			return 0;
		}

		if (curr>=rgno)
			curr=rgno-1;
		if (curr<0)
			return 1;
		rg[curr]->puttolistbox(lb);
	}
	else
		SendMessage(lb, LB_RESETCONTENT, (WPARAM)0, (LPARAM)0);
	return 0;
}

int installfile_base::putittolistbox(HWND lb1, HWND lb2, HWND lb3)
{
	int i;
	char buf[256];

	SendMessage(lb1, LB_RESETCONTENT, (WPARAM)0, (LPARAM)0);
	SendMessage(lb1, LB_SETCOUNT, (WPARAM)itno, (LPARAM)0);
	
	if (itno==0) {
		SendMessage(lb2, LB_RESETCONTENT, (WPARAM)0, (LPARAM)0);
		SendMessage(lb3, LB_RESETCONTENT, (WPARAM)0, (LPARAM)0);
		return 1;
	}

	for (i=0; i<itno; i++)
		SendMessage(lb1, LB_ADDSTRING, (WPARAM)0, (LPARAM)it[i]->name);
	SendMessage(lb1, LB_SETCURSEL, (WPARAM)curit, 0);

	SendMessage(lb2, LB_RESETCONTENT, (WPARAM)0, (LPARAM)0);
	SendMessage(lb3, LB_RESETCONTENT, (WPARAM)0, (LPARAM)0);
	SendMessage(lb2, LB_SETCOUNT, (WPARAM)fgno, (LPARAM)0);
	SendMessage(lb3, LB_SETCOUNT, (WPARAM)rgno, (LPARAM)0);

	for (i=0; i<it[curit]->fgno; i++) {
		strcpy(buf, "");
		sprintf(buf, "%d. %s", i+1, fg[it[curit]->fg[i]]->name);
		SendMessage(lb2, LB_ADDSTRING, (WPARAM)0, (LPARAM)buf);
	}

	for (i=0; i<it[curit]->rgno; i++) {
		strcpy(buf, "");
		sprintf(buf, "%d. %s", i+1, rg[it[curit]->rg[i]]->name);
		SendMessage(lb3, LB_ADDSTRING, (WPARAM)0, (LPARAM)buf);
	}
	return 0;
}

int installfile_base::addfgtoit(int index)
{
	it[curit]->addfilegroup(index);
	return 0;
}

int installfile_base::addrgtoit(int index)
{
	it[curit]->addreggroup(index);
	return 0;
}

int installfile_base::remfgfromit(int index)
{
	it[curit]->remfilegroup(index);
	return 0;
}

int installfile_base::remrgfromit(int index)
{
	it[curit]->remreggroup(index);
	return 0;
}

int installfile_base::compile(HWND progress/*, HWND progress2*/)
{
	return 0;
}

int installfile_base::load(char *path)
{
	MsgBox(MB_OK, "Internal error!");
	//This method's not defined for installfile_base class!
	return 1;
}

int installfile_base::save(char *path)
{
	MsgBox(MB_OK, "Internal error!");
	//This method's not defined for installfile_base class!
	return 1;
}

void installfile_base::parse_path(char *path)
{
	int i, j;
	char buf[2048], buf2[2048], buf3[2048], buf4[2048];

	strcpy(buf, path);
	strcpy(buf4, "");
	strcpy(buf3, "");
	strcpy(buf2, "");

	for (i=0;;i++) {
		if (buf[i]=='\0')
			break;

		if (buf[i]=='%') {
			i++;
			strcpy(buf3, "");
			for (j=0;;) {
				if (buf[i]=='%')
					break;
				if (buf[i]=='\0') {
					strcpy(path, buf4);
					return;
				}
				buf3[j++]=buf[i++];
			}
			buf3[j]='\0';

			if (!strcmpi(buf3, "p")||!strcmpi(buf3, "")) {
				strcat(buf4, "%");
			} else if (!strcmpi(buf3, "mydocuments")) {
				windows_registry_get_value(HKEY_CURRENT_USER, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders", "Personal", 0, buf2, 512);
				strcat(buf4, buf2);
			} else if (!strcmpi(buf3, "windowsdir")) {
				GetWindowsDirectory(buf2, 2048);
				strcat(buf4, buf2);
			} else if (!strcmpi(buf3, "windowssystem")) {
				GetSystemDirectory(buf2, 2048);
				strcat(buf4, buf2);
			} else if (!strcmpi(buf3, "programfiles")) {
				strcat(buf4, "C:\\Program Files");
			} else if (!strcmpi(buf3, "targetmenudir")) {
				strcat(buf4, defmenudir);
			} else if (!strcmpi(buf3, "targetprogramdir")) {
				strcat(buf4, defprogdir);
			} else if (!strcmpi(buf3, "windowsmenu")) {
				windows_registry_get_value(HKEY_CURRENT_USER, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders", "Start menu", 0, buf2, 512);
				strcat(buf4, buf2);
			} else if (!strcmpi(buf3, "windowsmenuprograms")) {
				windows_registry_get_value(HKEY_CURRENT_USER, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders", "Programs", 0, buf2, 512);
				strcat(buf4, buf2);
			} else if (!strcmpi(buf3, "temp")) {
				windows_registry_get_value(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\explorer\\VolumeCaches\\Temporary files", "folder", 0, buf2, 512);
				strcat(buf4, buf2);
			} else if (!strcmpi(buf3, "mypictures")) {
				windows_registry_get_value(HKEY_CURRENT_USER, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders", "My Pictures", 0, buf2, 512);
				strcat(buf4, buf2);
			} else if (!strcmpi(buf3, "myvideos")) {
				windows_registry_get_value(HKEY_CURRENT_USER, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders", "My Videos", 0, buf2, 512);
				strcat(buf4, buf2);
			} else if (!strcmpi(buf3, "menustartup")) {
				windows_registry_get_value(HKEY_CURRENT_USER, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders", "Startup", 0, buf2, 512);
				strcat(buf4, buf2);
			} else if (!strcmpi(buf3, "windowsdesktop")) {
				windows_registry_get_value(HKEY_CURRENT_USER, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders", "Desktop", 0, buf2, 512);
				strcat(buf4, buf2);
			} else if (!strcmpi(buf3, "windowsfonts")) {
				windows_registry_get_value(HKEY_CURRENT_USER, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders", "Fonts", 0, buf2, 512);
				strcat(buf4, buf2);
			} else if (!strcmpi(buf3, "favorites")) {
				windows_registry_get_value(HKEY_CURRENT_USER, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders", "Favorites", 0, buf2, 512);
				strcat(buf4, buf2);
			} else if (!strcmpi(buf3, "sendto")) {
				windows_registry_get_value(HKEY_CURRENT_USER, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders", "SendTo", 0, buf2, 512);
				strcat(buf4, buf2);
			}
		} else
			strncat(buf4, &buf[i], 1);
	}
	strcpy(path, buf4);
}
