/*
    CoolSetup installation system
    Copyright (C) 2001-2002 Andrej Krutak

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include <commctrl.h>
#include "zip.h"

class filegroupitem
{
public:
	char source[_MAX_PATH];
	char target[_MAX_PATH];
	int type;
	int link;
	char lname[64];
	char ltargetdir[128];
	char liconpath[_MAX_PATH+5];
	int liconnum;
	char lwrkdir[_MAX_DIR+_MAX_DRIVE];
	char ldescr[64];
public:
	filegroupitem();
};

class reggroupitem
{
public:
	int root;
	char path[256];
	char item[64];
	char value[256];
public:
	reggroupitem();
};

class filegroup
{
public:
	filegroupitem *fgi[20000];
	char name[256];
	int fgino;
	int rmfp;
	int installme;
public:
	filegroup();
	filegroup(char*);
	~filegroup();
	int additem(void);
	int removeitem(int index);
	int puttolistbox(HWND lb);
	int adddirectory(char* path, int ajc);
};

class reggroup
{
public:
	reggroupitem *rgi[20000];
	char name[256];
	int rgino;
	int installme;
public:
	reggroup();
	reggroup(char*);
	~reggroup();
	int additem(void);
	int removeitem(int index);
	int puttolistbox(HWND lb);
};

class installtype
{
public:
	int fg[32];
	int rg[32];
	char name[256];
	int fgno, rgno, fgcust, rgcust;
public:
	installtype();
	installtype(char*);
	//~installtype();
	int addfilegroup(int index);
	int addreggroup(int index);
	int remfilegroup(int index);
	int remreggroup(int index);
};

class installfile_base
{
public:
	filegroup *fg[32];
	reggroup *rg[32];
	installtype *it[32];
	
	int fgno, rgno, itno;
	char outputpath[1024];
	char windowcaption[256], bigcaption[256], copyright[256], uninstkey[256];
	char defprogdir[1024], defmenudir[1024], readmefile[1024], licensefile[1024], execinst[1024], execuninst[1024];
	int showbgwin, gofullscreen, showwelcome, showlicense, showreadme, showtarget, enableuninstallation, compressionstrength;
	COLORREF topcolor, bottomcolor;
	int overwriteprompt, progdircustom, menudircustom;
	char projpath[1024];
	int ajc, curit;
	int curf, curr;
	char tgtplatform[256];
public:
	installfile_base();
	~installfile_base();
	void initialize(void);
	void uninitialize(void);
	int remfgrp(int index);
	int remrgrp(int index);
	int newfgrp(char*);
	int newrgrp(char*);
	int addftogrp(void);
	int addrtogrp(void);
	int remffromgrp(int f, int index);
	int remrfromgrp(int f, int index);
	virtual int save(char *path);
	virtual int load(char *path);
	int newitype(char *name);
	int remitype(int index);
	int puttolistbox(HWND lb);
	int putrtolistbox(HWND lb);
	int putftolistbox(HWND lb);
	int putrctolistbox(HWND lb);
	int putfctolistbox(HWND lb);
	int putittolistbox(HWND lb1, HWND lb2, HWND lb3);
	int addfgtoit(int index);
	int addrgtoit(int index);
	int remfgfromit(int index);
	int remrgfromit(int index);
	virtual int compile(HWND progress/*, HWND progress2*/);
	void parse_path(char *path);
};

unsigned long ini_getnextint(FILE *file);
int ini_getnextline(FILE *file, char *buf);
int MsgBox(UINT fuStyle, char *pszFormat, ...);
int cs_get_progpath(char *string);
DWORD filetime(char *f, tm_zip *tmzip, DWORD *dt);